import java.awt.*;
import java.io.*;
import java.net.*;
import java.applet.*;
public class BreakAround2 extends Applet implements Runnable{
    Thread t;
    BCanvas bc;
    static BreakAround2 app;
    private static final long serialVersionUID = 630988756942600981L;
    public void init(){
//        super("BreakAround2Application");
//        pack();
        app=this;
        resize(440,480);
        setLayout(null);
        bc=new BCanvas(this);
        add(bc);
        bc.reshape(0,40,400,400);
        show();
        requestFocus();
        t=new Thread(this);
        t.start();
    }
    public static Image getImage(String filename){
        try{
            URL url=app.getClass().getResource("/"+filename);
            Image img=app.getToolkit().getImage(url);
            return img;
        }
        catch(Exception e){
        }
        return null;
    }
    public void run(){
        while(true){
            try{
                Thread.sleep(20);
                bc.repaint();
            }
            catch(Exception e){
            }
        }
    }
    public static void main(String[]args){
        new BreakAround2();
    }
    public boolean handleEvent(Event evt){
        if(evt.id==Event.WINDOW_DESTROY){
            System.exit(0);
        }
        if(evt.id==Event.MOUSE_MOVE){
            bc.buildpanel(evt.x);
        }
        if(evt.id==Event.KEY_PRESS||evt.id==Event.KEY_ACTION){
            if(evt.key==Event.ESCAPE||evt.key==27){
                bc.restart();
            }
        }
        return false;
    }
}
class BCanvas extends Canvas{
    BreakAround2 bar;
    Image one;
    Image two;
    Image three;
    Image four;
    Image five;
    Image img;
    Graphics h;
    Stone[][]s1=new Stone[5][5];
    Stone[][]s2=new Stone[5][5];
    Stone[][]s3=new Stone[5][5];
    Stone[][]s4=new Stone[5][5];
    Stone[][]s5=new Stone[5][5];
    Stone[][]s6=new Stone[5][5];
    Stone[][]s7=new Stone[5][5];
    Stone[][]s8=new Stone[5][5];
    Stone[][]s9=new Stone[5][5];
    int curscreen=5;
    double mousex;
    double alpha;
    Side panel1;
    Side panel2;
    Side panel3;
    Side panel4;
    double xpos;
    double ypos;
    double xdrift;
    double ydrift;
    boolean lost=false;
    MediaTracker tracker;
    private static final long serialVersionUID = 3939475268154085101L;
    public BCanvas(BreakAround2 bar){
        this.bar=bar;
        resize(400,440);
        ImFrameBreakAround2 im=new ImFrameBreakAround2();
        img=im.img;
        h=img.getGraphics();
        tracker=new MediaTracker(this);
        one=BreakAround2.getImage("one.gif");
        two=BreakAround2.getImage("two.gif");
        three=BreakAround2.getImage("three.gif");
        four=BreakAround2.getImage("four.gif");
        five=BreakAround2.getImage("five.gif");
        tracker.addImage(one,0);
        tracker.addImage(two,0);
        tracker.addImage(three,0);
        tracker.addImage(four,0);
        tracker.addImage(five,0);
        try{
            tracker.waitForID(0);
        }
        catch(Exception em){
        }
        build();
        buildpanel(50);
        xpos=200;
        ypos=300;
        xdrift=Math.cos(-Math.PI/2+0.01);
        ydrift=Math.sin(-Math.PI/2+0.01);
    }
    public synchronized void restart(){
        curscreen=5;
        alpha=0;
        lost=false;
        build();
        buildpanel(50);
        xpos=200;
        ypos=300;
        xdrift=Math.cos(-Math.PI/2+0.01);
        ydrift=Math.sin(-Math.PI/2+0.01);
    }
    public synchronized void buildpanel(int mousex){
        this.mousex=mousex;
        alpha=-Math.PI/2+(((double)mousex)/((double)400))*Math.PI*2;
        double xdown=Math.cos(alpha);
        double ydown=Math.sin(alpha);
        double xright=Math.cos(alpha-Math.PI/2);
        double yright=Math.sin(alpha-Math.PI/2);
        panel1=new Side(200+xdown*180,200+ydown*180,200+xdown*180+xright*40,200+ydown*180+yright*40);
        panel2=new Side(200+xdown*190,200+ydown*190,200+xdown*190+xright*40,200+ydown*190+yright*40);
        panel3=new Side(200+xdown*180,200+ydown*180,200+xdown*190,200+ydown*190);
        panel4=new Side(200+xdown*180+xright*40,200+ydown*180+yright*40,200+xdown*190+xright*40,200+ydown*190+yright*40);
    }
    public void build(){
        for(int i=0;i<5;i++){
            for(int j=0;j<5;j++){
                s1[i][j]=getStone(i,j);
                s2[i][j]=getStone(i,j);
                s3[i][j]=getStone(i,j);
                s4[i][j]=getStone(i,j);
                s5[i][j]=getStone(i,j);
                s6[i][j]=getStone(i,j);
                s7[i][j]=getStone(i,j);
                s8[i][j]=getStone(i,j);
                s9[i][j]=getStone(i,j);
            }
        }
    }
    public Stone getStone(int i,int j){
        int number=(int)(Math.random()*5)+1;
        double xleft=200-50+i*20;
        double yleft=200-50+j*20;
        Side s1=new Side(xleft,yleft,xleft+20,yleft+0);
        Side s2=new Side(xleft+20,yleft,xleft+20,yleft+20);
        Side s3=new Side(xleft+20,yleft+20,xleft+0,yleft+20);
        Side s4=new Side(xleft,yleft+20,xleft+0,yleft+0);
        Stone s=new Stone(number,s1,s2,s3,s4);
        s1.stone=s;
        s2.stone=s;
        s3.stone=s;
        s4.stone=s;
        return s;
    }
    public void paint(Graphics g){
    }
    public synchronized void update(Graphics g){
        h.setColor(Color.white);
        h.fillRect(0,0,600,600);
        h.setColor(Color.red);
        boolean l=false;
        boolean r=false;
        boolean u=false;
        boolean o=false;
        if(curscreen==1){
            l=true;
            o=true;
            r=false;
            u=false;
        }
        else if(curscreen==2){
            l=false;
            o=true;
            r=false;
            u=false;
        }
        else if(curscreen==3){
            l=false;
            o=true;
            r=true;
            u=false;
        }
        else if(curscreen==4){
            l=true;
            o=false;
            r=false;
            u=false;
        }
        else if(curscreen==5){
            l=false;
            o=false;
            r=false;
            u=false;
        }
        else if(curscreen==6){
            l=false;
            o=false;
            r=true;
            u=false;
        }
        else if(curscreen==7){
            l=true;
            o=false;
            r=false;
            u=true;
        }
        else if(curscreen==8){
            l=false;
            o=false;
            r=false;
            u=true;
        }
        else if(curscreen==9){
            l=false;
            o=false;
            r=true;
            u=true;
        }
        if(l){
            h.fillRect(100+0,100+0,10,400);
        }
        if(r){
            h.fillRect(100+390,100+0,10,400);
        }
        if(o){
            h.fillRect(100+0,100+0,400,10);
        }
        if(u){
            h.fillRect(100+0,100+390,400,10);
        }
        for(int i=0;i<5;i++){
            for(int j=0;j<5;j++){
                int num=0;
                if(curscreen==1){
                    num=s1[i][j].value;
                }
                else if(curscreen==2){
                    num=s2[i][j].value;
                }
                else if(curscreen==3){
                    num=s3[i][j].value;
                }
                else if(curscreen==4){
                    num=s4[i][j].value;
                }
                else if(curscreen==5){
                    num=s5[i][j].value;
                }
                else if(curscreen==6){
                    num=s6[i][j].value;
                }
                else if(curscreen==7){
                    num=s7[i][j].value;
                }
                else if(curscreen==8){
                    num=s8[i][j].value;
                }
                else if(curscreen==9){
                    num=s9[i][j].value;
                }
                if(num>0){
                    if(num==1){
                        h.drawImage(one,100+200-50+i*20,100+200-50+j*20,this);
                    }
                    else if(num==2){
                        h.drawImage(two,100+200-50+i*20,100+200-50+j*20,this);
                    }
                    else if(num==3){
                        h.drawImage(three,100+200-50+i*20,100+200-50+j*20,this);
                    }
                    else if(num==4){
                        h.drawImage(four,100+200-50+i*20,100+200-50+j*20,this);
                    }
                    else if(num==5){
                        h.drawImage(five,100+200-50+i*20,100+200-50+j*20,this);
                    }
                }
            }
        }
        Polygon pol=new Polygon();
        pol.addPoint((int)panel1.x1+100,(int)panel1.y1+100);
        pol.addPoint((int)panel4.x1+100,(int)panel4.y1+100);
        pol.addPoint((int)panel4.x2+100,(int)panel4.y2+100);
        pol.addPoint((int)panel2.x1+100,(int)panel2.y1+100);
        h.setColor(Color.blue);
        h.drawPolygon(pol);
        Side ballside=new Side(xpos,ypos,xpos+xdrift,ypos+ydrift);
        PointHolder ph=new PointHolder();
        for(int i=0;i<5;i++){
            for(int j=0;j<5;j++){
                Stone cs=null;
                if(curscreen==1){
                    cs=s1[i][j];
                }
                else if(curscreen==2){
                    cs=s2[i][j];
                }
                else if(curscreen==3){
                    cs=s3[i][j];
                }
                else if(curscreen==4){
                    cs=s4[i][j];
                }
                else if(curscreen==5){
                    cs=s5[i][j];
                }
                else if(curscreen==6){
                    cs=s6[i][j];
                }
                else if(curscreen==7){
                    cs=s7[i][j];
                }
                else if(curscreen==8){
                    cs=s8[i][j];
                }
                else if(curscreen==9){
                    cs=s9[i][j];
                }
                if(cs.value>0){
                    Point p1=cs.s1.cut(ballside);
                    if(p1.r>0&&p1.r<1&&p1.s>0&&p1.s<1){
                        ph.add(p1);
                    }
                    Point p2=cs.s2.cut(ballside);
                    if(p2.r>0&&p2.r<1&&p2.s>0&&p2.s<1){
                        ph.add(p2);
                    }
                    Point p3=cs.s3.cut(ballside);
                    if(p3.r>0&&p3.r<1&&p3.s>0&&p3.s<1){
                        ph.add(p3);
                    }
                    Point p4=cs.s4.cut(ballside);
                    if(p4.r>0&&p4.r<1&&p4.s>0&&p4.s<1){
                        ph.add(p4);
                    }
                }
            }
        }
        Point pb1=panel1.cut(ballside);
//System.out.println("px1: "+panel1.x1+" py1: "+panel1.y1+" panel1.x2: "+panel1.x2+" panel1.y2: "+panel1.x2);
//System.out.println("bx1: "+ballside.x1+" by1: "+ballside.y1+" bx2: "+ballside.x2+" by2: "+ballside.y2);
//System.out.println("x: "+pb1.r+" y: "+pb1.s);
        if(pb1.r>0&&pb1.r<1&&pb1.s>0&&pb1.s<1){
            ph.add(pb1);
        }
        Point pb2=panel2.cut(ballside);
        if(pb2.r>0&&pb2.r<1&&pb2.s>0&&pb2.s<1){
            ph.add(pb2);
        }
        Point pb3=panel3.cut(ballside);
        if(pb3.r>0&&pb3.r<1&&pb3.s>0&&pb3.s<1){
            ph.add(pb3);
        }
        Point pb4=panel4.cut(ballside);
        if(pb4.r>0&&pb4.r<1&&pb4.s>0&&pb4.s<1){
            ph.add(pb4);
        }
        double lb=1;
        Point p=null;
        int n=ph.points.length;
        for(int i=0;i<n;i++){
            if(ph.points[i].s<lb){
                p=ph.points[i];
                lb=ph.points[i].s;
            }
        }
        boolean schraeg=false;
        if(p!=null){
            Side s=p.target;
            Side normal=s.getNormal();
            Side base=new Side(p.x,p.y,s.x2,s.y2);
//System.out.println("s.x1: "+s.x1+" s.y1: "+s.y1);
//System.out.println("base x1: "+base.x1+" base y1: "+base.y1+" base.x2: "+base.x2+" base.y2: "+base.y2);
//System.out.println("normal x1: "+normal.x1+" normal.y1: "+normal.y1+" normal.x2: "+normal.x2+" normal.y2: "+normal.y2);
//System.out.println("xpos: "+xpos+" ypos: "+ypos);
            Point tar=new Point(xpos,ypos);
            Point coord=base.getCoord(tar,normal);
            if(coord.x==-1&&coord.y==-1){
            }
            else{
//System.out.println("p.x: "+p.x+" p.y: "+p.y);
//System.out.println("p.r: "+p.r+" p.s: "+p.s);
//System.out.println("coord.x: "+coord.x+" coord.y: "+coord.y);
                double len2=Math.sqrt((xpos-p.x)*(xpos-p.x)+(ypos-p.y)*(ypos-p.y));
                double xposb=-coord.x*(s.x2-p.x)+coord.y*(normal.x2-normal.x1);
                double yposb=-coord.x*(s.y2-p.y)+coord.y*(normal.y2-normal.y1);
//System.out.println("xposb: "+xposb+" yposb: "+yposb);
                if(s!=null&&s.stone!=null){
                    s.stone.value--;
                }
                if(s==panel1){
                    double pos1=Math.sqrt((p.x-panel1.x1)*(p.x-panel1.x1)+(p.y-panel1.y1)*(p.y-panel1.y1));
                    double bxdiff=(s.x2-s.x1)/40;
                    double bydiff=(s.y2-s.y1)/40;
                    xposb=xposb+(pos1-20)*len2*bxdiff/10;
                    yposb=yposb+(pos1-20)*len2*bydiff/10;
                }
                if(s==panel2){
                    double pos2=Math.sqrt((p.x-panel2.x1)*(p.x-panel2.x1)+(p.y-panel2.y1)*(p.y-panel2.y1));
                    double bxdiff=(s.x2-s.x1)/40;
                    double bydiff=(s.y2-s.y1)/40;
                    xposb=xposb+(pos2-20)*len2*bxdiff/10;
                    yposb=yposb+(pos2-20)*len2*bydiff/10;
                }
                if(s==panel3){
                    double pos3=Math.sqrt((p.x-panel3.x1)*(p.x-panel3.x1)+(p.y-panel3.y1)*(p.y-panel3.y1));
                    double bxdiff=(s.x2-s.x1)/10;
                    double bydiff=(s.y2-s.y1)/10;
                    xposb=xposb+(pos3-5)*len2*bxdiff/5;
                    yposb=yposb+(pos3-5)*len2*bydiff/5;
                }
                if(s==panel4){
                    double pos4=Math.sqrt((p.x-panel4.x1)*(p.x-panel4.x1)+(p.y-panel4.y1)*(p.y-panel4.y1));
                    double bxdiff=(s.x2-s.x1)/10;
                    double bydiff=(s.y2-s.y1)/10;
                    xposb=xposb+(pos4-5)*len2*bxdiff/5;
                    yposb=yposb+(pos4-5)*len2*bydiff/5;
                }
                double len=Math.sqrt(xposb*xposb+yposb*yposb);
                double len3=1-len2;
//System.out.println("len: "+len);
//System.out.println("len2: "+len2);
//System.out.println("len3: "+len3);
                xpos=p.x+xposb*len3/len;
                ypos=p.y+yposb*len3/len;
                xdrift=xposb/len;
                ydrift=yposb/len;
                schraeg=true;
            }
        }
        boolean l2=false;
        boolean r2=false;
        boolean o2=false;
        boolean u2=false;
        if(xpos<0){
            xpos=400;
            l2=true;
            if(l){
                lost=true;
            }
        }
        if(ypos<0){
            ypos=400;
            o2=true;
            if(o){
                lost=true;
            }
        }
        if(xpos>400){
            xpos=0;
            r2=true;
            if(r){
                lost=true;
            }
        }
        if(ypos>400){
            ypos=0;
            u2=true;
            if(u){
                lost=true;
            }
        }
        h.setColor(Color.blue);
        if(lost){
            h.drawString("You have lost!",120,120);
        }
        else{
            boolean[][]bol=new boolean[3][3];
            int c=0;
            int ix=0;
            int iy=0;
            for(int i=0;i<3;i++){
                for(int j=0;j<3;j++){
                    c++;
                    if(c==curscreen){
                        ix=j;
                        iy=i;
                    }
                }
            }
            if(u2){
                iy=iy+1;
            }
            if(o2){
                iy=iy-1;
            }
            if(r2){
                ix=ix+1;
            }
            if(l2){
                ix=ix-1;
            }
            bol[ix][iy]=true;
            c=0;
            for(int i=0;i<3;i++){
                for(int j=0;j<3;j++){
                    c++;
                    if(bol[j][i]){
                        curscreen=c;
                    }
                }
            }
        }
        boolean won=true;
        for(int i=0;i<5;i++){
            for(int j=0;j<5;j++){
                if(s1[i][j].value>0){
                    won=false;
                }
                if(s2[i][j].value>0){
                    won=false;
                }
                if(s3[i][j].value>0){
                    won=false;
                }
                if(s4[i][j].value>0){
                    won=false;
                }
                if(s5[i][j].value>0){
                    won=false;
                }
                if(s6[i][j].value>0){
                    won=false;
                }
                if(s7[i][j].value>0){
                    won=false;
                }
                if(s8[i][j].value>0){
                    won=false;
                }
                if(s9[i][j].value>0){
                    won=false;
                }
            }
        }
        h.setColor(Color.blue);
        if(won){
            h.drawString("You have won!",120,120);
        }
        h.fillOval(100+(int)xpos-3,100+(int)ypos-3,6,6);
        if(!schraeg&&!won&&!lost){
            xpos=xpos+xdrift;
            ypos=ypos+ydrift;
        }
        g.drawImage(img,-100,-100,this);
        paint(g);
    }
}
class ImFrameBreakAround2 extends Frame{
    Image img;
    private static final long serialVersionUID = -6890520692953506850L;
    public ImFrameBreakAround2(){
        pack();
        img=createImage(800,600);
    }
}
class PointHolder{
    Point[]points=new Point[0];
    public PointHolder(){
    }
    public void add(Point p){
        int n=points.length;
        Point[]points2=new Point[n+1];
        for(int i=0;i<n;i++){
            points2[i]=points[i];
        }
        points2[n]=p;
        points=points2;
    }
}
class Stone{
    int value;
    Side s1;
    Side s2;
    Side s3;
    Side s4;
    public Stone(int value,Side s1,Side s2,Side s3,Side s4){
        this.value=value;
        this.s1=s1;
        this.s2=s2;
        this.s3=s3;
        this.s4=s4;
    }
}
class Side{
    double x1;
    double x2;
    double y1;
    double y2;
    Stone stone;
    public Side(double x1,double y1,double x2,double y2){
        this.x1=x1;
        this.y1=y1;
        this.x2=x2;
        this.y2=y2;
    }
    public Side(double x1,double y1,double x2,double y2,Stone stone){
        this.x1=x1;
        this.y1=y1;
        this.x2=x2;
        this.y2=y2;
        this.stone=stone;
    }
    public Side getNormal(){
        double a=x2-x1;
        double b=y2-y1;
        double c=1;
        double d=0;
        if(b!=0){
            d=-a/b;
        }
        else{
            c=0;
            d=1;
        }
        Side ret=new Side(x1,y1,x1+c,y1+d);
        return ret;
    }
    public Point getCoord(Point point,Side b){
        double[][]matrix=new double[3][2];
        matrix[0][0]=x2-x1;
        matrix[0][1]=y2-y1;
        matrix[1][0]=b.x2-b.x1;
        matrix[1][1]=b.y2-b.y1;
        matrix[2][0]=point.x-x1;
        matrix[2][1]=point.y-y1;
        if(matrix[0][0]==0){
            double[][]matrix2=new double[3][2];
            matrix2[0][0]=matrix[0][1];
            matrix2[0][1]=matrix[0][0];
            matrix2[1][0]=matrix[1][1];
            matrix2[1][1]=matrix[1][0];
            matrix2[2][0]=matrix[2][1];
            matrix2[2][1]=matrix[2][0];
            matrix=matrix2;
        }
        if(matrix[0][0]==0){
            return new Point(-1,-1);
        }
        double coeff=matrix[0][1]/matrix[0][0];
        matrix[0][1]=matrix[0][1]-coeff*matrix[0][0];
        matrix[1][1]=matrix[1][1]-coeff*matrix[1][0];
        matrix[2][1]=matrix[2][1]-coeff*matrix[2][0];
        if(matrix[1][1]==0){
            return new Point(-1,-1);
        }
        double s=matrix[2][1]/matrix[1][1];
        double r=(matrix[2][0]-matrix[1][0]*s)/matrix[0][0];
        return new Point(r,s);
    }
    public Point cut(Side b){
        double[][]matrix=new double[3][2];
        matrix[0][0]=x2-x1;
        matrix[0][1]=y2-y1;
        matrix[1][0]=-(b.x2-b.x1);
        matrix[1][1]=-(b.y2-b.y1);
        matrix[2][0]=-x1+b.x1;
        matrix[2][1]=-y1+b.y1;
        if(matrix[0][0]==0){
            double[][]matrix2=new double[3][2];
            matrix2[0][0]=matrix[0][1];
            matrix2[0][1]=matrix[0][0];
            matrix2[1][0]=matrix[1][1];
            matrix2[1][1]=matrix[1][0];
            matrix2[2][0]=matrix[2][1];
            matrix2[2][1]=matrix[2][0];
            matrix=matrix2;
        }
        if(matrix[0][0]==0){
            return new Point(-1,-1);
        }
        double coeff=matrix[0][1]/matrix[0][0];
        matrix[0][1]=matrix[0][1]-coeff*matrix[0][0];
        matrix[1][1]=matrix[1][1]-coeff*matrix[1][0];
        matrix[2][1]=matrix[2][1]-coeff*matrix[2][0];
        if(matrix[1][1]==0){
            return new Point(-1,-1);
        }
        double s=matrix[2][1]/matrix[1][1];
        double r=(matrix[2][0]-matrix[1][0]*s)/matrix[0][0];
        return new Point(x1+r*(x2-x1),y1+r*(y2-y1),r,s,this);
    }
}
class Point{
    double x;
    double y;
    double r;
    double s;
    Side target;
    public Point(double x,double y){
        this.x=x;
        this.y=y;
        r=-1;
        s=-1;
    }
    public Point(double x,double y,double r,double s,Side target){
        this.x=x;
        this.y=y;
        this.r=r;
        this.s=s;
        this.target=target;
    }
}
