import java.io.*;
import java.net.*;
import java.awt.*;
import java.util.*;
import java.applet.*;
public class CubeMain extends Applet implements Runnable{
    Thread t;
    Button play;
    Button generate;
    TextField tf;
    Button login;
    TextArea ta;
    boolean playb;
    boolean generateb;
    boolean loginb;
    Generator generator;
    String ip="127.0.0.1";
    static CubeMain app2;
    Panel p1;
    Cubewar2009 p2;
    private static final long serialVersionUID = 3924777136713260770L;
    public void init(){
//        super("Cubewar 2009");
//        pack();
        app2=this;
        resize(440,480);
        setLayout(null);
        play=new Button("play: two players, one computer");
        generate=new Button("start world server");
        tf=new TextField("127.0.0.1");
        login=new Button("log in world server");
        ta=new TextArea();
        p1=new Panel();
        p1.setLayout(null);
        p1.add(play);
        p1.add(generate);
        p1.add(tf);
        p1.add(login);
        add(p1);
        generate.hide();
        tf.hide();
        login.hide();
        p1.add(ta);
        p1.reshape(0,0,400,440);
        ta.appendText("steering: \ncursor keys, enter, delete\n");
        ta.appendText("If a base is selected, you can use delete \nto switch between gun movement and camera movement\n\n");
        play.reshape(10,40,380,27);
        generate.reshape(10,70,380,27);
        tf.reshape(10,100,380,27);
        login.reshape(10,130,380,27);
        ta.reshape(10,160,380,200);
        show();
        requestFocus();
        t=new Thread(this);
        t.start();
    }
    public static InputStream getInputStream(String filename){
        try{
//            FileInputStream fis=new FileInputStream(filename);
            InputStream is=app2.getClass().getResourceAsStream("/"+filename);
            return is;
        }
        catch(Exception e){
            e.printStackTrace(System.out);
        }
        return null;
    }
    public void run(){
        try{
//            Socket soc=new Socket("www.google.de",80);
//            ip=soc.getLocalAddress().getHostAddress();
            ip="127.0.0.1";
        }
        catch(Exception ef){
        }
//        ta.appendText("your ip address is: "+ip+"\n");
        while(true){
            try{
                Thread.sleep(100);
                if(playb){
                    playb=false;
                    p1.hide();
                    p2=new Cubewar2009(System.currentTimeMillis(),null,null,0);
//                    addKeyListener(p2);
                }
                if(generateb){
                    generateb=false;
                    if(generator!=null){
                        try{
                            generator.seso.close();
                        }
                        catch(Exception f){
                        }
                    }
                    generator=new Generator(this);
                }
                if(loginb){
                    loginb=false;
                    new Loginer(this);
                }
            }
            catch(Exception e){
                e.printStackTrace(System.out);
            }
        }
    }
    public static void main(String[]args){
        new CubeMain();
    }
    public boolean handleEvent(Event evt){
        if(evt.id==Event.WINDOW_DESTROY){
            System.exit(0);
        }
        if(evt.id==Event.ACTION_EVENT){
            if(evt.target==play){
                playb=true;
            }
            if(evt.target==generate){
                generateb=true;
            }
            if(evt.target==login){
                loginb=true;
            }
        }
        if(evt.id==Event.KEY_PRESS||evt.id==Event.KEY_ACTION){
            if(p2!=null){
                p2.process(evt.key);
            }
        }
        return false;
    }
}
class Generator implements Runnable{
    Thread t;
    ServerSocket seso;
    CubeMain cm;
    public Generator(CubeMain cm){
        this.cm=cm;
        t=new Thread(this);
        t.start();
    }
    public void run(){
        try{
            seso=new ServerSocket(8009);
            cm.ta.append("waiting for logins\nat port 8009\n");
            while(true){
                new Serve(cm,seso.accept());
            }
        }
        catch(Exception e){
            cm.ta.append("server creation error: "+e+"\n");
        }
    }
}
class Serve implements Runnable{
    Thread t;
    Socket so;
    CubeMain cm;
    long time;
    public Serve(CubeMain cm,Socket so){
        this.cm=cm;
        this.so=so;
        t=new Thread(this);
        t.start();
    }
    public void run(){
        time=System.currentTimeMillis();
        try{
            InputStream is=so.getInputStream();
            OutputStream os=so.getOutputStream();
            PrintStream ps=new PrintStream(os);
            ps.println(""+time);
            DataInputStream dis=new DataInputStream(is);
            cm.p2=new Cubewar2009(time,ps,dis,2);
//            cm.addKeyListener(cm.p2);
        }
        catch(Exception e){
        }
    }
}
class Loginer implements Runnable{
    Thread t;
    CubeMain cm;
    public Loginer(CubeMain cm){
        this.cm=cm;
        t=new Thread(this);
        t.start();
    }
    public void run(){
        try{
            Socket so=new Socket(cm.tf.getText(),8009);
            InputStream is=so.getInputStream();
            OutputStream os=so.getOutputStream();
            PrintStream ps=new PrintStream(os);
            DataInputStream dis=new DataInputStream(is);
            long r=new Long(dis.readLine()).longValue();
            cm.p2=new Cubewar2009(r,ps,dis,1);
//            cm.addKeyListener(cm.p2);
        }
        catch(Exception e){
            cm.ta.append("login connection error: "+e+"\n");
        }
    }
}
class Cubewar2009 extends Panel implements Runnable{
    Random rand;
    Thread t;
    EngineCubeMain eng;
    Group[][][]groups=new Group[10][10][10];
    Group[][][]worms=new Group[10][10][10];
    Group[][][]cannons=new Group[10][10][10];
    Group[][][]explo=new Group[10][10][10];
    Color[][][]exploc=new Color[10][10][10];
    int[][][]explocount=new int[10][10][10];
    Worm[]worms1=new Worm[5];
    Worm[]worms2=new Worm[5];
    Vektor k1v=new Vektor(0,0,0);
    Vektor k2v=new Vektor(0,0,0);
    Kugel k1;
    Kugel k2;
    int state=0;
    int curworm1=0;
    int curworm2=0;
    boolean change=false;
    int wait1=0;
    int wait2=0;
    boolean k1isadded=false;
    boolean k2isadded=false;
    Vektor cameraposplus;
    Vektor camerapos;
    double alpha=0;
    double beta=0;
    int actionnr=0;
    CubeRunner cr;
    boolean running=true;
    boolean wall=false;
    PrintStream ps;
    DataInputStream dis;
    int player;
    String pstring1="";
    String pstring2="";
    double alphab=0;
    double betab=0;
    double xtrans=0;
    double ytrans=0;
    double ztrans=0;
    int gc=0;
    private static final long serialVersionUID = 6762162176740732081L;
    public Cubewar2009(long r,PrintStream ps,DataInputStream dis,int player){
//        super("Astro Solutions Cubewar2009");
//        pack();
//System.out.println("xxx");
        CubeMain.app2.add(this);
        reshape(0,0,400,440);
//        resize(400,440);
        setLayout(null);
        rand=new Random(r);
        this.ps=ps;
        this.dis=dis;
        this.player=player;
        if(player==1){
            pstring1="(you) ";
            pstring2="(other) ";
        }
        if(player==2){
            pstring2="(you) ";
            pstring1="(other) ";
        }
        eng=new EngineCubeMain();
        eng.loadVeks();
        eng.setStatus("");
        add(eng);
        eng.reshape(0,40,400,400);
        show();
        cameraposplus=new Vektor(0,0,0);
        camerapos=new Vektor(0,0,0);
        k1=new Kugel(Color.blue,Color.blue,k1v,15);
        k2=new Kugel(Color.blue,Color.blue,k2v,15);
//        eng.add(k1);
//        eng.add(k2);
        cr=new CubeRunner(this);
        build();
        CubeMain.app2.p1.hide();
        show();
        CubeMain.app2.requestFocus();
        t=new Thread(this);
        t.start();
    }
    public int random(int max){
        int ret=rand.nextInt()%max;
        if(ret<0){
            ret=-ret;
        }
        return ret;
    }
    public void setWallOn(){
        wall=true;
    }
    public void setWallOff(){
        wall=false;
    }
    public synchronized void runcontent1(){
                if(state==0){
                    eng.setStatus("player 1 "+pstring1+"select base");
                }
                if(state==1){
                    eng.setStatus("player 1 "+pstring1+"select direction");
                }
                if(state==2&&worms1[curworm1]!=null){
                    eng.setStatus("pulver: "+worms1[curworm1].pulver);
                }
                if(state==3||state==4){
                    eng.setStatus("player 1 "+pstring1+"shooting");
                }
                if(state==10){
                    eng.setStatus("player 2 "+pstring2+"select base");
                }
                if(state==11){
                    eng.setStatus("player 2 "+pstring2+"select direction");
                }
                if(state==12&&worms2[curworm2]!=null){
                    eng.setStatus("pulver: "+worms2[curworm2].pulver);
                }
                if(state==13||state==14){
                    eng.setStatus("player 2 "+pstring2+"shooting");
                }
                step();
                if(gc>=100){
                    gc=0;
                    System.gc();
                }
                gc=gc+1;
                boolean all1=true;
                for(int i=0;i<5;i++){
                    if(worms1[i]!=null){
                        all1=false;
                    }
                }
                boolean all2=true;
                for(int i=0;i<5;i++){
                    if(worms2[i]!=null){
                        all2=false;
                    }
                }
                boolean all=all1||all2;
                if(all1){
                    eng.setStatus("Player 1 "+pstring1+"eliminated");
                }
                else{
                    if(state<10&&worms1[curworm1]!=null){
                        if(state<3){
                            alpha=worms1[curworm1].alpha;
                            beta=worms1[curworm1].beta;
                        }
                        else{
                            alpha=worms1[curworm1].alphab;
                            beta=worms1[curworm1].betab;
                        }
                        camerapos.x=worms1[curworm1].xbase;
                        camerapos.y=worms1[curworm1].ybase;
                        camerapos.z=worms1[curworm1].zbase;
                    }                    
                }
                if(all2){
                    eng.setStatus("Player 2 "+pstring2+"eliminated");
                }
                else{
                    if(state>=10&&state<20&&worms2[curworm2]!=null){
                        if(state<13){
                            alpha=worms2[curworm2].alpha;
                            beta=worms2[curworm2].beta;
                        }
                        else{
                            alpha=worms2[curworm2].alphab;
                            beta=worms2[curworm2].betab;
                        }
                        camerapos.x=worms2[curworm2].xbase;
                        camerapos.y=worms2[curworm2].ybase;
                        camerapos.z=worms2[curworm2].zbase;
                    }
                }
                cameraposplus.x=Math.cos(alpha)*300;
                cameraposplus.y=Math.sin(alpha)*300;
                xtrans=camerapos.x+cameraposplus.x;
                ytrans=camerapos.y+cameraposplus.y;
                ztrans=camerapos.z+cameraposplus.z;
                alphab=alpha;
                betab=beta;
                setWallOn();
                eng.transform(-xtrans,-ytrans,-ztrans);
                alphab=alphab+Math.PI;
                if(alphab>2*Math.PI){
                    alphab=alphab-2*Math.PI;
                }
                eng.rotLeft2(-alphab);
                eng.rotLeft(-alphab);
                eng.rotUp2(-betab);
                eng.rotUp(betab);
                eng.setOn();
    }
    public synchronized void runcontent2(){
                eng.setOff();
                eng.rotUp2(betab);
                eng.rotUp(-betab);
                eng.rotLeft2(alphab);
                eng.rotLeft(alphab);
                eng.transform(xtrans,ytrans,ztrans);
                setWallOff();
    }
    public void run(){
        while(running){
                runcontent1();
                eng.move();
                eng.repaint();
                try{
                    Thread.sleep(100);
                }
                catch(Exception e){
                }
                runcontent2();
        }
    }
    public void build(){
        for(int i=0;i<5;i++){
            boolean run1=true;
            int x=0;
            int y=0;
            int z=0;
            while(run1){
                x=random(10);
                y=random(10);
                z=random(9);
                if(groups[x][y][z]==null&&groups[x][y][z+1]==null&&(z==0||groups[x][y][z-1]==null)){
                    run1=false;
                }
            }
            worms1[i]=new Worm(0);
            worms1[i].x=x;
            worms1[i].y=y;
            worms1[i].z=z;
            worms1[i].xbase=x*100+50;
            worms1[i].ybase=y*100+50;
            worms1[i].zbase=z*100+150;
            groups[x][y][z]=ObjectGenerator.getPlayer1();
            groups[x][y][z].transform(x*100,y*100,z*100);
            eng.add(groups[x][y][z]);
            worms[x][y][z]=ObjectGenerator.getWorm1();
            worms[x][y][z].transform(x*100,y*100,(z+1)*100+10);
            eng.add(worms[x][y][z]);
            cannons[x][y][z]=ObjectGenerator.getCannon1();
            cannons[x][y][z].transform(x*100,y*100,(z+1)*100+10);
            eng.add(cannons[x][y][z]);
        }
        for(int i=0;i<5;i++){
            boolean run1=true;
            int x=0;
            int y=0;
            int z=0;
            while(run1){
                x=random(10);
                y=random(10);
                z=random(9);
                if(groups[x][y][z]==null&&groups[x][y][z+1]==null&&(z==0||groups[x][y][z-1]==null)){
                    run1=false;
                }
            }
            worms2[i]=new Worm(1);
            worms2[i].x=x;
            worms2[i].y=y;
            worms2[i].z=z;
            worms2[i].xbase=x*100+50;
            worms2[i].ybase=y*100+50;
            worms2[i].zbase=z*100+150;
            groups[x][y][z]=ObjectGenerator.getPlayer2();
            groups[x][y][z].transform(x*100,y*100,z*100);
            eng.add(groups[x][y][z]);
            worms[x][y][z]=ObjectGenerator.getWorm2();
            worms[x][y][z].transform(x*100,y*100,(z+1)*100+10);
            eng.add(worms[x][y][z]);
            cannons[x][y][z]=ObjectGenerator.getCannon2();
            cannons[x][y][z].transform(x*100,y*100,(z+1)*100+10);
            eng.add(cannons[x][y][z]);
        }
        for(int i=0;i<25;i++){
            boolean run1=true;
            int x=0;
            int y=0;
            int z=0;
            while(run1){
                x=random(10);
                y=random(10);
                z=random(9);
                if(groups[x][y][z]==null&&groups[x][y][z+1]==null&&(z==0||groups[x][y][z-1]==null)){
                    run1=false;
                }
            }
            groups[x][y][z]=ObjectGenerator.getNeutral();
            groups[x][y][z].transform(x*100,y*100,z*100);
            eng.add(groups[x][y][z]);
        }
    }
//    public void keyPressed(KeyEvent evt){
//        CubeMain.app2.requestFocus();
//        process(evt);
//    }
    public synchronized void process(int key){
//            CubeMain.app2.requestFocus();
//System.out.println("key: "+key);
            if(key==27||key==Event.ESCAPE){
                hide();
//                CubeMain.app2.removeKeyListener(this);
                running=false;
                CubeMain.app2.p1.show();
            }
            if(key==Event.LEFT){
                cr.actionnr=1;
            }
            if(key==Event.RIGHT){
                cr.actionnr=2;
            }
            if(key==Event.DOWN){
                cr.actionnr=4;
            }
            if(key==Event.UP){
                cr.actionnr=3;
            }
            if(key==Event.ENTER||key==10||key==13){
                cr.actionnr=5;
            }
            if(key==Event.DELETE){
                cr.actionnr=6;
            }
    }
    public synchronized void action(int action){
        if(state==0){
            if(action==1){
                if(curworm1==0){
                    curworm1=4;
                }
                else{
                    curworm1--;
                }
                boolean all=true;
                for(int i=0;i<5;i++){
                    if(worms1[i]!=null){
                        all=false;
                    }
                }
                if(all){
                    return;
                }
                if(worms1[curworm1]==null){
                    action(1);
                }
            }
            else if(action==2){
                if(curworm1==0){
                    curworm1=4;
                }
                else{
                    curworm1--;
                }
                boolean all=true;
                for(int i=0;i<5;i++){
                    if(worms1[i]!=null){
                        all=false;
                    }
                }
                if(all){
                    return;
                }
                if(worms1[curworm1]==null){
                    action(2);
                }
            }
            else if(action==5){
                state=1;
            }
            if(worms1[curworm1].inverse){
                eng.setInverseOn();
            }
            else{
                eng.setInverseOff();
            }
        }
        else if(state==1){
            if(action==6){
                if(worms1[curworm1].camera){
                    worms1[curworm1].camera=false;
                }
                else{
                    worms1[curworm1].camera=true;
                }
            }
            else if(action==1){
                if(worms1[curworm1].camera){
                    worms1[curworm1].alpha=worms1[curworm1].alpha+Math.PI/90;
                    if(worms1[curworm1].alpha>2*Math.PI){
                        worms1[curworm1].alpha=worms1[curworm1].alpha-2*Math.PI;
                    }
                }
                else{
                    while(change){
                        try{
                            Thread.yield();
                        }
                        catch(Exception e){
                        }
                    }
                    worms1[curworm1].xdiff=worms1[curworm1].xdiff-Math.PI/90;
                }
            }
            else if(action==2){
                if(worms1[curworm1].camera){
                    worms1[curworm1].alpha=worms1[curworm1].alpha-Math.PI/90;
                    if(worms1[curworm1].alpha<0){
                        worms1[curworm1].alpha=worms1[curworm1].alpha+2*Math.PI;
                    }
                }
                else{
                    while(change){
                        try{
                            Thread.yield();
                        }
                        catch(Exception e){
                        }
                    }
                    worms1[curworm1].xdiff=worms1[curworm1].xdiff+Math.PI/90;
                }
            }
            else if(action==3){
                if(worms1[curworm1].camera){
                    if(worms1[curworm1].inverse){
                        worms1[curworm1].beta=worms1[curworm1].beta+Math.PI/90;
                        if(worms1[curworm1].beta>Math.PI/2){
                            worms1[curworm1].beta=Math.PI/2;
                            worms1[curworm1].beta=Math.PI/2-Math.PI/90;
                            worms1[curworm1].alpha=worms1[curworm1].alpha+Math.PI;
                            if(worms1[curworm1].alpha>2*Math.PI){
                                worms1[curworm1].alpha=worms1[curworm1].alpha-2*Math.PI;
                            }
                            worms1[curworm1].inverse=false;
                            eng.setInverseOff();
                        }
                    }
                    else{
                        worms1[curworm1].beta=worms1[curworm1].beta-Math.PI/90;
                        if(worms1[curworm1].beta<-Math.PI/2){
                            worms1[curworm1].beta=-Math.PI/2;
//                            worms1[curworm1].beta=-Math.PI/2+Math.PI/90;
//                            worms1[curworm1].alpha=worms1[curworm1].alpha+Math.PI;
//                            if(worms1[curworm1].alpha>2*Math.PI){
//                                worms1[curworm1].alpha=worms1[curworm1].alpha-2*Math.PI;
//                            }
//                            worms1[curworm1].inverse=true;
//                            eng.setInverseOn();
                        }
                    }
                }
                else{
                    while(change){
                        try{
                            Thread.yield();
                        }
                        catch(Exception e){
                        }
                    }
                    worms1[curworm1].ydiff=worms1[curworm1].ydiff+Math.PI/90;
                }
            }
            else if(action==4){
                if(worms1[curworm1].camera){
                    if(!worms1[curworm1].inverse){
                        worms1[curworm1].beta=worms1[curworm1].beta+Math.PI/90;
                        if(worms1[curworm1].beta>Math.PI/2){
                            worms1[curworm1].beta=Math.PI/2;
//                            worms1[curworm1].beta=Math.PI/2-Math.PI/90;
//                            worms1[curworm1].alpha=worms1[curworm1].alpha+Math.PI;
//                            if(worms1[curworm1].alpha>2*Math.PI){
//                                worms1[curworm1].alpha=worms1[curworm1].alpha-2*Math.PI;
//                            }
//                            worms1[curworm1].inverse=true;
//                            eng.setInverseOn();
                        }
                    }
                    else{
                        worms1[curworm1].beta=worms1[curworm1].beta-Math.PI/90;
                        if(worms1[curworm1].beta<-Math.PI/2){
                            worms1[curworm1].beta=-Math.PI/2+Math.PI/90;
                            worms1[curworm1].alpha=worms1[curworm1].alpha+Math.PI;
                            if(worms1[curworm1].alpha>2*Math.PI){
                                worms1[curworm1].alpha=worms1[curworm1].alpha-2*Math.PI;
                            }
                            worms1[curworm1].inverse=false;
                            eng.setInverseOff();
                        }
                    }
                }
                else{
                    while(change){
                        try{
                            Thread.yield();
                        }
                        catch(Exception e){
                        }
                    }
                    worms1[curworm1].ydiff=worms1[curworm1].ydiff-Math.PI/90;
                }
            }
            else if(action==5){
                state=2;
            }
        }
        else if(state==2){
            if(action==4){
                worms1[curworm1].pulver=worms1[curworm1].pulver-1;
            }
            else if(action==3){
                worms1[curworm1].pulver=worms1[curworm1].pulver+1;
            }
            else if(action==5){
//                worms1[curworm1].xbase=worms1[curworm1].x*100+50;
//                worms1[curworm1].ybase=worms1[curworm1].y*100+50;
//                worms1[curworm1].zbase=worms1[curworm1].z*100+150;
                while(worms1[curworm1].xdiff!=0&&worms1[curworm1].ydiff!=0){
                    try{
                        Thread.sleep(100);
                    }
                    catch(Exception e){
                    }
                }
                double h=Math.cos(worms1[curworm1].angley);
                if(h<0){
                    h=-h;
                }
                worms1[curworm1].zdrift=Math.sin(worms1[curworm1].angley)*worms1[curworm1].pulver;
                worms1[curworm1].xdrift=Math.cos(worms1[curworm1].anglex)*h*worms1[curworm1].pulver;
                worms1[curworm1].ydrift=Math.sin(worms1[curworm1].anglex)*h*worms1[curworm1].pulver;
                worms1[curworm1].t=0;
                worms1[curworm1].alphab=worms1[curworm1].alpha;
                worms1[curworm1].betab=worms1[curworm1].beta;
                worms1[curworm1].inverseb=worms1[curworm1].inverse;
                state=3;
            }
        }

        else if(state==3){
            if(action==1){
                worms1[curworm1].alphab=worms1[curworm1].alphab+Math.PI/90;
                if(worms1[curworm1].alphab>2*Math.PI){
                    worms1[curworm1].alphab=worms1[curworm1].alphab-2*Math.PI;
                }
            }
            else if(action==2){
                worms1[curworm1].alphab=worms1[curworm1].alphab-Math.PI/90;
                if(worms1[curworm1].alphab<0){
                    worms1[curworm1].alphab=worms1[curworm1].alphab+2*Math.PI;
                }
            }
            else if(action==3){
                if(worms1[curworm1].inverseb){
                    worms1[curworm1].betab=worms1[curworm1].betab+Math.PI/90;
                    if(worms1[curworm1].betab>Math.PI/2){
                        worms1[curworm1].betab=Math.PI/2-Math.PI/90;
                        worms1[curworm1].alphab=worms1[curworm1].alphab+Math.PI;
                        if(worms1[curworm1].alphab>2*Math.PI){
                            worms1[curworm1].alphab=worms1[curworm1].alphab-2*Math.PI;
                        }
                        worms1[curworm1].inverseb=false;
                        eng.setInverseOff();
                    }
                }
                else{
                    worms1[curworm1].betab=worms1[curworm1].betab-Math.PI/90;
                    if(worms1[curworm1].betab<-Math.PI/2){
                        worms1[curworm1].betab=-Math.PI/2;
//                        worms1[curworm1].betab=-Math.PI/2+Math.PI/90;
//                        worms1[curworm1].alphab=worms1[curworm1].alphab+Math.PI;
//                        if(worms1[curworm1].alphab>2*Math.PI){
//                            worms1[curworm1].alphab=worms1[curworm1].alphab-2*Math.PI;
//                        }
//                        worms1[curworm1].inverseb=true;
//                        eng.setInverseOn();
                    }
                }
            }
            else if(action==4){
                if(!worms1[curworm1].inverseb){
                    worms1[curworm1].betab=worms1[curworm1].betab+Math.PI/90;
                    if(worms1[curworm1].betab>Math.PI/2){
                        worms1[curworm1].betab=Math.PI/2;
//                        worms1[curworm1].betab=Math.PI/2-Math.PI/90;
//                        worms1[curworm1].alphab=worms1[curworm1].alphab+Math.PI;
//                        if(worms1[curworm1].alphab>2*Math.PI){
//                            worms1[curworm1].alphab=worms1[curworm1].alphab-2*Math.PI;
//                        }
//                        worms1[curworm1].inverseb=true;
//                        eng.setInverseOn();
                    }
                }
                else{
                    worms1[curworm1].betab=worms1[curworm1].betab-Math.PI/90;
                    if(worms1[curworm1].betab<-Math.PI/2){
                        worms1[curworm1].betab=-Math.PI/2+Math.PI/90;
                        worms1[curworm1].alphab=worms1[curworm1].alphab+Math.PI;
                        if(worms1[curworm1].alphab>2*Math.PI){
                            worms1[curworm1].alphab=worms1[curworm1].alphab-2*Math.PI;
                        }
                        worms1[curworm1].inverseb=false;
                        eng.setInverseOff();
                    }
                }
            }
        }

        else if(state==10){
            if(action==1){
                if(curworm2<4){
                    curworm2++;
                }
                else{
                    curworm2=0;
                }
                boolean all=true;
                for(int i=0;i<5;i++){
                    if(worms2[i]!=null){
                        all=false;
                    }
                }
                if(all){
                    return;
                }
                if(worms2[curworm2]==null){
                    action(1);
                }
            }
            else if(action==2){
                if(curworm2==0){
                    curworm2=4;
                }
                else{
                    curworm2--;
                }
                boolean all=true;
                for(int i=0;i<5;i++){
                    if(worms2[i]!=null){
                        all=false;
                    }
                }
                if(all){
                    return;
                }
                if(worms2[curworm2]==null){
                    action(2);
                }
            }
            else if(action==5){
                state=11;
            }
            if(worms2[curworm2].inverse){
                eng.setInverseOn();
            }
            else{
                eng.setInverseOff();
            }
        }
        else if(state==11){
            if(action==6){
                if(worms2[curworm2].camera){
                    worms2[curworm2].camera=false;
                }
                else{
                    worms2[curworm2].camera=true;
                }
            }
            else if(action==1){
                if(worms2[curworm2].camera){
                    worms2[curworm2].alpha=worms2[curworm2].alpha+Math.PI/90;
                    if(worms2[curworm2].alpha>2*Math.PI){
                        worms2[curworm2].alpha=worms2[curworm2].alpha-2*Math.PI;
                    }
                }
                else{
                    while(change){
                        try{
                            Thread.yield();
                        }
                        catch(Exception e){
                        }
                    }
                    worms2[curworm2].xdiff=worms2[curworm2].xdiff-Math.PI/90;
                }
            }
            else if(action==2){
                if(worms2[curworm2].camera){
                    worms2[curworm2].alpha=worms2[curworm2].alpha-Math.PI/90;
                    if(worms2[curworm2].alpha<0){
                        worms2[curworm2].alpha=worms2[curworm2].alpha+2*Math.PI;
                    }
                }
                else{
                    while(change){
                        try{
                            Thread.yield();
                        }
                        catch(Exception e){
                        }
                    }
                    worms2[curworm2].xdiff=worms2[curworm2].xdiff+Math.PI/90;
                }
            }
            else if(action==3){
                if(worms2[curworm2].camera){
                    if(worms2[curworm2].inverse){
                        worms2[curworm2].beta=worms2[curworm2].beta+Math.PI/90;
                        if(worms2[curworm2].beta>Math.PI/2){
                            worms2[curworm2].beta=Math.PI/2-Math.PI/90;
                            worms2[curworm2].alpha=worms2[curworm2].alpha+Math.PI;
                            if(worms2[curworm2].alpha>2*Math.PI){
                                worms2[curworm2].alpha=worms2[curworm2].alpha-2*Math.PI;
                            }
                            worms2[curworm2].inverse=false;
                            eng.setInverseOff();
                        }
                    }
                    else{
                        worms2[curworm2].beta=worms2[curworm2].beta-Math.PI/90;
                        if(worms2[curworm2].beta<-Math.PI/2){
                            worms2[curworm2].beta=-Math.PI/2;
//                            worms2[curworm2].beta=-Math.PI/2+Math.PI/90;
//                            worms2[curworm2].alpha=worms2[curworm2].alpha+Math.PI;
//                            if(worms2[curworm2].alpha>2*Math.PI){
//                                worms2[curworm2].alpha=worms2[curworm2].alpha-2*Math.PI;
//                            }
//                            worms2[curworm2].inverse=true;
//                            eng.setInverseOn();
                        }
                    }
                }
                else{
                    while(change){
                        try{
                            Thread.yield();
                        }
                        catch(Exception e){
                        }
                    }
                    worms2[curworm2].ydiff=worms2[curworm2].ydiff+Math.PI/90;
                }
            }
            else if(action==4){
                if(worms2[curworm2].camera){
                    if(!worms2[curworm2].inverse){
                        worms2[curworm2].beta=worms2[curworm2].beta+Math.PI/90;
                        if(worms2[curworm2].beta>Math.PI/2){
                            worms2[curworm2].beta=Math.PI/2;
//                            worms2[curworm2].beta=Math.PI/2-Math.PI/90;
//                            worms2[curworm2].alpha=worms2[curworm2].alpha+Math.PI;
//                            if(worms2[curworm2].alpha>2*Math.PI){
//                                worms2[curworm2].alpha=worms2[curworm2].alpha-2*Math.PI;
//                            }
//                            worms2[curworm2].inverse=true;
//                            eng.setInverseOn();
                        }
                    }
                    else{
                        worms2[curworm2].beta=worms2[curworm2].beta-Math.PI/90;
                        if(worms2[curworm2].beta<-Math.PI/2){
                            worms2[curworm2].beta=-Math.PI/2+Math.PI/90;
                            worms2[curworm2].alpha=worms2[curworm2].alpha+Math.PI;
                            if(worms2[curworm2].alpha>2*Math.PI){
                                worms2[curworm2].alpha=worms2[curworm2].alpha-2*Math.PI;
                            }
                            worms2[curworm2].inverse=false;
                            eng.setInverseOff();
                        }
                    }
                }
                else{
                    while(change){
                        try{
                            Thread.yield();
                        }
                        catch(Exception e){
                        }
                    }
                    worms2[curworm2].ydiff=worms2[curworm2].ydiff-Math.PI/90;
                }
            }
            else if(action==5){
                state=12;
            }
        }
        else if(state==12){
            if(action==4){
                worms2[curworm2].pulver=worms2[curworm2].pulver-1;
            }
            else if(action==3){
                worms2[curworm2].pulver=worms2[curworm2].pulver+1;
            }
            else if(action==5){
//                worms2[curworm2].xbase=worms2[curworm2].x*100+50;
//                worms2[curworm2].ybase=worms2[curworm2].y*100+50;
//                worms2[curworm2].zbase=worms2[curworm2].z*100+150;
                while(worms2[curworm2].xdiff!=0&&worms2[curworm2].ydiff!=0){
                    try{
                        Thread.sleep(100);
                    }
                    catch(Exception e){
                    }
                }
                double h=Math.cos(worms2[curworm2].angley);
                if(h<0){
                    h=-h;
                }
                worms2[curworm2].zdrift=Math.sin(worms2[curworm2].angley)*worms2[curworm2].pulver;
                worms2[curworm2].xdrift=Math.cos(worms2[curworm2].anglex)*h*worms2[curworm2].pulver;
                worms2[curworm2].ydrift=Math.sin(worms2[curworm2].anglex)*h*worms2[curworm2].pulver;
                worms2[curworm2].t=0;
                worms2[curworm2].alphab=worms2[curworm2].alpha;
                worms2[curworm2].betab=worms2[curworm2].beta;
                worms2[curworm2].inverseb=worms2[curworm2].inverse;
                state=13;
            }
        }

        else if(state==13){
            if(action==1){
                worms2[curworm2].alphab=worms2[curworm2].alphab+Math.PI/90;
                if(worms2[curworm2].alphab>2*Math.PI){
                    worms2[curworm2].alphab=worms2[curworm2].alphab-2*Math.PI;
                }
            }
            else if(action==2){
                worms2[curworm2].alphab=worms2[curworm2].alphab-Math.PI/90;
                if(worms2[curworm2].alphab<0){
                    worms2[curworm2].alphab=worms2[curworm2].alphab+2*Math.PI;
                }
            }
            else if(action==3){
                if(worms2[curworm2].inverseb){
                    worms2[curworm2].betab=worms2[curworm2].betab+Math.PI/90;
                    if(worms2[curworm2].betab>Math.PI/2){
                        worms2[curworm2].betab=Math.PI/2-Math.PI/90;
                        worms2[curworm2].alphab=worms2[curworm2].alphab+Math.PI;
                        if(worms2[curworm2].alphab>2*Math.PI){
                            worms2[curworm2].alphab=worms2[curworm2].alphab-2*Math.PI;
                        }
                        worms2[curworm2].inverseb=false;
                        eng.setInverseOff();
                    }
                }
                else{
                    worms2[curworm2].betab=worms2[curworm2].betab-Math.PI/90;
                    if(worms2[curworm2].betab<-Math.PI/2){
                        worms2[curworm2].betab=-Math.PI/2;
//                        worms2[curworm2].betab=-Math.PI/2+Math.PI/90;
//                        worms2[curworm2].alphab=worms2[curworm2].alphab+Math.PI;
//                        if(worms2[curworm2].alphab>2*Math.PI){
//                            worms2[curworm2].alphab=worms2[curworm2].alphab-2*Math.PI;
//                        }
//                        worms2[curworm2].inverseb=true;
//                        eng.setInverseOn();
                    }
                }
            }
            else if(action==4){
                if(!worms2[curworm2].inverseb){
                    worms2[curworm2].betab=worms2[curworm2].betab+Math.PI/90;
                    if(worms2[curworm2].betab>Math.PI/2){
                        worms2[curworm2].betab=Math.PI/2;
//                        worms2[curworm2].betab=Math.PI/2-Math.PI/90;
//                        worms2[curworm2].alphab=worms2[curworm2].alphab+Math.PI;
//                        if(worms2[curworm2].alphab>2*Math.PI){
//                            worms2[curworm2].alphab=worms2[curworm2].alphab-2*Math.PI;
//                        }
//                        worms2[curworm2].inverseb=true;
//                        eng.setInverseOn();
                    }
                }
                else{
                    worms2[curworm2].betab=worms2[curworm2].betab-Math.PI/90;
                    if(worms2[curworm2].betab<-Math.PI/2){
                        worms2[curworm2].betab=-Math.PI/2+Math.PI/90;
                        worms2[curworm2].alphab=worms2[curworm2].alphab+Math.PI;
                        if(worms2[curworm2].alphab>2*Math.PI){
                            worms2[curworm2].alphab=worms2[curworm2].alphab-2*Math.PI;
                        }
                        worms2[curworm2].inverseb=false;
                        eng.setInverseOff();
                    }
                }
            }
        }
    }
    public void step(){
        change=true;
        for(int i=0;i<5;i++){
            if(worms1[i]!=null){
                int xp=worms1[i].x;
                int yp=worms1[i].y;
                int zp=worms1[i].z;
                double xd=worms1[i].xdiff;
                double yd=worms1[i].ydiff;
                double xa=worms1[i].anglex;
                double ya=worms1[i].angley;
                if(ya+yd>Math.PI/2){
                    yd=Math.PI/2-ya;
                }
                if(ya+yd<-Math.PI/2){
                    yd=-Math.PI/2-ya;
                }
                worms1[i].xdiff=0;
                worms1[i].ydiff=0;
                worms1[i].anglex+=xd;
                worms1[i].angley+=yd;
                if(xd!=0||yd!=0){
                    worms[xp][yp][zp].transform(-xp*100-50,-yp*100-50,-zp*100-150);
                    worms[xp][yp][zp].rotLeft(-xa);
                    worms[xp][yp][zp].rotUp(yd);
                    worms[xp][yp][zp].rotLeft(xa+xd);
                    worms[xp][yp][zp].transform(xp*100+50,yp*100+50,zp*100+150);
                    cannons[xp][yp][zp].transform(-xp*100-50,-yp*100-50,-zp*100-150);
                    cannons[xp][yp][zp].rotLeft(-xa);
                    cannons[xp][yp][zp].rotUp(yd);
                    cannons[xp][yp][zp].rotLeft(xa+xd);
                    cannons[xp][yp][zp].transform(xp*100+50,yp*100+50,zp*100+150);
                }
            }
        }
        for(int i=0;i<5;i++){
            if(worms2[i]!=null){
                int xp=worms2[i].x;
                int yp=worms2[i].y;
                int zp=worms2[i].z;
                double xd=worms2[i].xdiff;
                double yd=worms2[i].ydiff;
                double xa=worms2[i].anglex;
                double ya=worms2[i].angley;
                if(ya+yd>Math.PI/2){
                    yd=Math.PI/2-ya;
                }
                if(ya+yd<-Math.PI/2){
                    yd=-Math.PI/2-ya;
                }
                worms2[i].xdiff=0;
                worms2[i].ydiff=0;
                worms2[i].anglex+=xd;
                worms2[i].angley+=yd;
                if(xd!=0||yd!=0){
                    worms[xp][yp][zp].transform(-xp*100-50,-yp*100-50,-zp*100-150);
                    worms[xp][yp][zp].rotLeft(-xa);
                    worms[xp][yp][zp].rotUp(yd);
                    worms[xp][yp][zp].rotLeft(xa+xd);
                    worms[xp][yp][zp].transform(xp*100+50,yp*100+50,zp*100+150);
                    cannons[xp][yp][zp].transform(-xp*100-50,-yp*100-50,-zp*100-150);
                    cannons[xp][yp][zp].rotLeft(-xa);
                    cannons[xp][yp][zp].rotUp(yd);
                    cannons[xp][yp][zp].rotLeft(xa+xd);
                    cannons[xp][yp][zp].transform(xp*100+50,yp*100+50,zp*100+150);
                }
            }
        }
        change=false;
        for(int i=0;i<10;i++){
            for(int j=0;j<10;j++){
                for(int k=0;k<10;k++){
                    if(explo[i][j][k]!=null){
                        int rc=random(256);
                        Color cn=new Color(rc,0,0);
                        explo[i][j][k].change(exploc[i][j][k],cn);
                        exploc[i][j][k]=cn;
                        if(explocount[i][j][k]>0){
                            explocount[i][j][k]--;
                        }
                        else{
                            eng.remove(explo[i][j][k]);
                            explo[i][j][k]=null;
                        }
                    }
                }
            }
        }
        if(state==4){
            if(wait1>0){
                wait1--;
            }
            else{
                state=10;
            }
        }
        if(state==14){
            if(wait2>0){
                wait2--;
            }
            else{
                state=0;
            }
        }
        if(state==3){
            if(!k1isadded){
                eng.add(k1);
                k1isadded=true;
            }
            k1v.x=worms1[curworm1].xbase+worms1[curworm1].t*worms1[curworm1].xdrift;
            k1v.y=worms1[curworm1].ybase+worms1[curworm1].t*worms1[curworm1].ydrift;
            k1v.z=worms1[curworm1].zbase+worms1[curworm1].t*worms1[curworm1].zdrift-0.5*worms1[curworm1].t*worms1[curworm1].t;
            worms1[curworm1].t+=0.5;
            int xp=(int)(k1v.x/100);
            int yp=(int)(k1v.y/100);
            int zp=(int)(k1v.z/100);
            if(zp<0){
                state=4;
                wait1=1;
                k1v.x=0;
                k1v.y=0;
                k1v.z=0;
                if(k1isadded){
                    eng.remove(k1);
                    k1isadded=false;
                }
            }
            if(xp>=0&&xp<10&&yp>=0&&yp<10&&zp>=0&&zp<10){
                if(groups[xp][yp][zp]!=null){
                    removeworm(xp,yp,zp);
                    eng.remove(groups[xp][yp][zp]);
                    groups[xp][yp][zp]=null;
                    exploc[xp][yp][zp]=new Color(255,0,0);
                    explo[xp][yp][zp]=ObjectGenerator.getExplosion(exploc[xp][yp][zp]);
                    explo[xp][yp][zp].transform(xp*100,yp*100,zp*100);
                    explocount[xp][yp][zp]=10;
                    eng.add(explo[xp][yp][zp]);
                    state=4;
                    wait1=20;
                    k1v.x=0;
                    k1v.y=0;
                    k1v.z=0;
                    if(k1isadded){
                        eng.remove(k1);
                        k1isadded=false;
                    }
                }
                if(worms[xp][yp][zp]!=null){
                    eng.remove(worms[xp][yp][zp]);
                    worms[xp][yp][zp]=null;
                }
                if(cannons[xp][yp][zp]!=null){
                    eng.remove(cannons[xp][yp][zp]);
                    cannons[xp][yp][zp]=null;
                }
            }
        }
        if(state==13){
            if(!k2isadded){
                eng.add(k2);
                k2isadded=true;
            }
            k2v.x=worms2[curworm2].xbase+worms2[curworm2].t*worms2[curworm2].xdrift;
            k2v.y=worms2[curworm2].ybase+worms2[curworm2].t*worms2[curworm2].ydrift;
            k2v.z=worms2[curworm2].zbase+worms2[curworm2].t*worms2[curworm2].zdrift-0.5*worms2[curworm2].t*worms2[curworm2].t;
            worms2[curworm2].t+=0.5;
            int xp=(int)(k2v.x/100);
            int yp=(int)(k2v.y/100);
            int zp=(int)(k2v.z/100);
            if(zp<0){
                state=14;
                wait2=1;
                k2v.x=0;
                k2v.y=0;
                k2v.z=0;
                if(k2isadded){
                    eng.remove(k2);
                    k2isadded=false;
                }
            }
            if(xp>=0&&xp<10&&yp>=0&&yp<10&&zp>=0&&zp<10){
                if(groups[xp][yp][zp]!=null){
                    removeworm(xp,yp,zp);
                    eng.remove(groups[xp][yp][zp]);
                    groups[xp][yp][zp]=null;
                    exploc[xp][yp][zp]=new Color(255,0,0);
                    explo[xp][yp][zp]=ObjectGenerator.getExplosion(exploc[xp][yp][zp]);
                    explo[xp][yp][zp].transform(xp*100,yp*100,zp*100);
                    explocount[xp][yp][zp]=10;
                    eng.add(explo[xp][yp][zp]);
                    state=14;
                    wait2=20;
                    k2v.x=0;
                    k2v.y=0;
                    k2v.z=0;
                    if(k2isadded){
                        eng.remove(k2);
                        k2isadded=false;
                    }
                }
                if(worms[xp][yp][zp]!=null){
                    eng.remove(worms[xp][yp][zp]);
                    worms[xp][yp][zp]=null;
                }
                if(cannons[xp][yp][zp]!=null){
                    eng.remove(cannons[xp][yp][zp]);
                    cannons[xp][yp][zp]=null;
                }
            }
        }
    }
    public void removeworm(int x,int y,int z){
        for(int i=0;i<5;i++){
            if(worms1[i]!=null){
                if(worms1[i].x==x&&worms1[i].y==y&&worms1[i].z==z){
                    worms1[i]=null;
                }
            }
        }
        for(int i=0;i<5;i++){
            if(worms2[i]!=null){
                if(worms2[i].x==x&&worms2[i].y==y&&worms2[i].z==z){
                    worms2[i]=null;
                }
            }
        }
    }
}
class ObjectGenerator{
    public static Group getNeutral(){
Group g=new Group();
PaintGroup pg=new PaintGroup();
Color ca1=new Color(200,200,200);
Color cb1=new Color(64,64,64);
Polygon p1=new Polygon(ca1,cb1);
Vektor v1=new Vektor(0.01,0.01,100.0);
p1.add(v1);
Vektor v2=new Vektor(99.9,0.01,100.0);
p1.add(v2);
Vektor v3=new Vektor(99.9,99.9,100.0);
p1.add(v3);
Vektor v4=new Vektor(0.01,99.9,100.0);
p1.add(v4);
p1.setPaintGroup(pg);
g.add(p1);
Color ca2=new Color(0,0,255);
Color cb2=new Color(100,0,200);
Polygon p2=new Polygon(ca2,cb2);
Vektor v5=new Vektor(52.666666666666664,37.333333333333336,100.0);
p2.add(v5);
Vektor v6=new Vektor(11.333333,37.66666,100.0);
p2.add(v6);
Vektor v7=new Vektor(11.3333333,42.33333333333,100.0);
p2.add(v7);
Vektor v8=new Vektor(37.6,42.333333,100.0);
p2.add(v8);
Vektor v9=new Vektor(37.6,89.63333333333333,100.0);
p2.add(v9);
Vektor v10=new Vektor(42.333333333333336,89.63,100.0);
p2.add(v10);
Vektor v11=new Vektor(42.333333333333336,57.666666666666664,100.0);
p2.add(v11);
Vektor v12=new Vektor(89.66666666666667,57.666666666666664,100.0);
p2.add(v12);
Vektor v13=new Vektor(89.66666666666667,53.0,100.0);
p2.add(v13);
Vektor v14=new Vektor(57.66666666,53.0,100.0);
p2.add(v14);
Vektor v15=new Vektor(57.666666666666,11.333333333333334,100.0);
p2.add(v15);
Vektor v16=new Vektor(52.666666666666664,11.333333333333334,100.0);
p2.add(v16);
p2.setPaintGroup(pg);
g.add(p2);
Color ca3=new Color(200,200,200);
Color cb3=new Color(200,200,200);
Polygon p3=new Polygon(ca3,cb3);
Vektor v17=new Vektor(43.0,42.6,100.0);
p3.add(v17);
Vektor v18=new Vektor(52.333333333333,42.6,100.0);
p3.add(v18);
Vektor v19=new Vektor(52.33333329999999,52.6,100.0);
p3.add(v19);
Vektor v20=new Vektor(43.0,52.6,100.0);
p3.add(v20);
p3.setPaintGroup(pg);
g.add(p3);

PaintGroup pgb=new PaintGroup();
Color ca1b=new Color(200,200,200);
Color cb1b=new Color(64,64,64);
Polygon p1b=new Polygon(ca1b,cb1b);
Vektor v1b=new Vektor(0.01,0.01,0.0);
p1b.add(v1b);
Vektor v2b=new Vektor(99.9,0.01,0.0);
p1b.add(v2b);
Vektor v3b=new Vektor(99.9,99.9,0.0);
p1b.add(v3b);
Vektor v4b=new Vektor(0.01,99.9,0.0);
p1b.add(v4b);
p1b.setPaintGroup(pgb);
g.add(p1b);
Color ca2b=new Color(0,0,255);
Color cb2b=new Color(100,0,200);
Polygon p2b=new Polygon(ca2b,cb2b);
Vektor v5b=new Vektor(52.666666666666664,37.333333333333336,0.0);
p2b.add(v5b);
Vektor v6b=new Vektor(11.333333,37.66666,0.0);
p2b.add(v6b);
Vektor v7b=new Vektor(11.3333333,42.33333333333,0.0);
p2b.add(v7b);
Vektor v8b=new Vektor(37.6,42.333333,0.0);
p2b.add(v8b);
Vektor v9b=new Vektor(37.6,89.63333333333333,0.0);
p2b.add(v9b);
Vektor v10b=new Vektor(42.333333333333336,89.63,0.0);
p2b.add(v10b);
Vektor v11b=new Vektor(42.333333333333336,57.666666666666664,0.0);
p2b.add(v11b);
Vektor v12b=new Vektor(89.66666666666667,57.666666666666664,0.0);
p2b.add(v12b);
Vektor v13b=new Vektor(89.66666666666667,53.0,0.0);
p2b.add(v13b);
Vektor v14b=new Vektor(57.66666666,53.0,0.0);
p2b.add(v14b);
Vektor v15b=new Vektor(57.666666666666,11.333333333333334,0.0);
p2b.add(v15b);
Vektor v16b=new Vektor(52.666666666666664,11.333333333333334,0.0);
p2b.add(v16b);
p2b.setPaintGroup(pgb);
g.add(p2b);
Color ca3b=new Color(200,200,200);
Color cb3b=new Color(200,200,200);
Polygon p3b=new Polygon(ca3b,cb3b);
Vektor v17b=new Vektor(43.0,42.6,0.0);
p3b.add(v17b);
Vektor v18b=new Vektor(52.333333333333,42.6,0.0);
p3b.add(v18b);
Vektor v19b=new Vektor(52.33333329999999,52.6,0.0);
p3b.add(v19b);
Vektor v20b=new Vektor(43.0,52.6,0.0);
p3b.add(v20b);
p3b.setPaintGroup(pgb);
g.add(p3b);

PaintGroup pgc=new PaintGroup();
Color ca1c=new Color(200,200,200);
Color cb1c=new Color(64,64,64);
Polygon p1c=new Polygon(ca1c,cb1c);
Vektor v1c=new Vektor(0.01,0.0,99.99);
p1c.add(v1c);
Vektor v2c=new Vektor(99.9,0.0,99.99);
p1c.add(v2c);
Vektor v3c=new Vektor(99.9,0.0,0.09999999999999432);
p1c.add(v3c);
Vektor v4c=new Vektor(0.01,0.0,0.09999999999999432);
p1c.add(v4c);
p1c.setPaintGroup(pgc);
g.add(p1c);
Color ca2c=new Color(0,0,255);
Color cb2c=new Color(100,0,200);
Polygon p2c=new Polygon(ca2c,cb2c);
Vektor v5c=new Vektor(52.666666666666664,0.0,62.666666666666664);
p2c.add(v5c);
Vektor v6c=new Vektor(11.333333,0.0,62.33334);
p2c.add(v6c);
Vektor v7c=new Vektor(11.3333333,0.0,57.66666666667);
p2c.add(v7c);
Vektor v8c=new Vektor(37.6,0.0,57.666667);
p2c.add(v8c);
Vektor v9c=new Vektor(37.6,0.0,10.366666666666674);
p2c.add(v9c);
Vektor v10c=new Vektor(42.333333333333336,0.0,10.370000000000005);
p2c.add(v10c);
Vektor v11c=new Vektor(42.333333333333336,0.0,42.333333333333336);
p2c.add(v11c);
Vektor v12c=new Vektor(89.66666666666667,0.0,42.333333333333336);
p2c.add(v12c);
Vektor v13c=new Vektor(89.66666666666667,0.0,47.0);
p2c.add(v13c);
Vektor v14c=new Vektor(57.66666666,0.0,47.0);
p2c.add(v14c);
Vektor v15c=new Vektor(57.666666666666,0.0,88.66666666666667);
p2c.add(v15c);
Vektor v16c=new Vektor(52.666666666666664,0.0,88.66666666666667);
p2c.add(v16c);
p2c.setPaintGroup(pgc);
g.add(p2c);
Color ca3c=new Color(200,200,200);
Color cb3c=new Color(200,200,200);
Polygon p3c=new Polygon(ca3c,cb3c);
Vektor v17c=new Vektor(43.0,0.0,57.4);
p3c.add(v17c);
Vektor v18c=new Vektor(52.333333333333,0.0,57.4);
p3c.add(v18c);
Vektor v19c=new Vektor(52.33333329999999,0.0,47.4);
p3c.add(v19c);
Vektor v20c=new Vektor(43.0,0.0,47.4);
p3c.add(v20c);
p3c.setPaintGroup(pgc);
g.add(p3c);

PaintGroup pgd=new PaintGroup();
Color ca1d=new Color(200,200,200);
Color cb1d=new Color(64,64,64);
Polygon p1d=new Polygon(ca1d,cb1d);
Vektor v1d=new Vektor(100.0,0.01,99.99);
p1d.add(v1d);
Vektor v2d=new Vektor(100.0,99.9,99.99);
p1d.add(v2d);
Vektor v3d=new Vektor(100.0,99.9,0.09999999999999432);
p1d.add(v3d);
Vektor v4d=new Vektor(100.0,0.01,0.09999999999999432);
p1d.add(v4d);
p1d.setPaintGroup(pgd);
g.add(p1d);
Color ca2d=new Color(0,0,255);
Color cb2d=new Color(100,0,200);
Polygon p2d=new Polygon(ca2d,cb2d);
Vektor v5d=new Vektor(100.0,52.666666666666664,62.666666666666664);
p2d.add(v5d);
Vektor v6d=new Vektor(100.0,11.333333,62.33334);
p2d.add(v6d);
Vektor v7d=new Vektor(100.0,11.3333333,57.66666666667);
p2d.add(v7d);
Vektor v8d=new Vektor(100.0,37.6,57.666667);
p2d.add(v8d);
Vektor v9d=new Vektor(100.0,37.6,10.366666666666674);
p2d.add(v9d);
Vektor v10d=new Vektor(100.0,42.333333333333336,10.370000000000005);
p2d.add(v10d);
Vektor v11d=new Vektor(100.0,42.333333333333336,42.333333333333336);
p2d.add(v11d);
Vektor v12d=new Vektor(100.0,89.66666666666667,42.333333333333336);
p2d.add(v12d);
Vektor v13d=new Vektor(100.0,89.66666666666667,47.0);
p2d.add(v13d);
Vektor v14d=new Vektor(100.0,57.66666666,47.0);
p2d.add(v14d);
Vektor v15d=new Vektor(100.0,57.666666666666,88.66666666666667);
p2d.add(v15d);
Vektor v16d=new Vektor(100.0,52.666666666666664,88.66666666666667);
p2d.add(v16d);
p2d.setPaintGroup(pgd);
g.add(p2d);
Color ca3d=new Color(200,200,200);
Color cb3d=new Color(200,200,200);
Polygon p3d=new Polygon(ca3d,cb3d);
Vektor v17d=new Vektor(100.0,43.0,57.4);
p3d.add(v17d);
Vektor v18d=new Vektor(100.0,52.333333333333,57.4);
p3d.add(v18d);
Vektor v19d=new Vektor(100.0,52.33333329999999,47.4);
p3d.add(v19d);
Vektor v20d=new Vektor(100.0,43.0,47.4);
p3d.add(v20d);
p3d.setPaintGroup(pgd);
g.add(p3d);

PaintGroup pge=new PaintGroup();
Color ca1e=new Color(200,200,200);
Color cb1e=new Color(64,64,64);
Polygon p1e=new Polygon(ca1e,cb1e);
Vektor v1e=new Vektor(99.99,100.0,99.99);
p1e.add(v1e);
Vektor v2e=new Vektor(0.09999999999999432,100.0,99.99);
p1e.add(v2e);
Vektor v3e=new Vektor(0.09999999999999432,100.0,0.09999999999999432);
p1e.add(v3e);
Vektor v4e=new Vektor(99.99,100.0,0.09999999999999432);
p1e.add(v4e);
p1e.setPaintGroup(pge);
g.add(p1e);
Color ca2e=new Color(0,0,255);
Color cb2e=new Color(100,0,200);
Polygon p2e=new Polygon(ca2e,cb2e);
Vektor v5e=new Vektor(47.333333333333336,100.0,62.666666666666664);
p2e.add(v5e);
Vektor v6e=new Vektor(88.666667,100.0,62.33334);
p2e.add(v6e);
Vektor v7e=new Vektor(88.66666670000001,100.0,57.66666666667);
p2e.add(v7e);
Vektor v8e=new Vektor(62.4,100.0,57.666667);
p2e.add(v8e);
Vektor v9e=new Vektor(62.4,100.0,10.366666666666674);
p2e.add(v9e);
Vektor v10e=new Vektor(57.666666666666664,100.0,10.370000000000005);
p2e.add(v10e);
Vektor v11e=new Vektor(57.666666666666664,100.0,42.333333333333336);
p2e.add(v11e);
Vektor v12e=new Vektor(10.333333333333329,100.0,42.333333333333336);
p2e.add(v12e);
Vektor v13e=new Vektor(10.333333333333329,100.0,47.0);
p2e.add(v13e);
Vektor v14e=new Vektor(42.33333334,100.0,47.0);
p2e.add(v14e);
Vektor v15e=new Vektor(42.333333333334,100.0,88.66666666666667);
p2e.add(v15e);
Vektor v16e=new Vektor(47.333333333333336,100.0,88.66666666666667);
p2e.add(v16e);
p2e.setPaintGroup(pge);
g.add(p2e);
Color ca3e=new Color(200,200,200);
Color cb3e=new Color(200,200,200);
Polygon p3e=new Polygon(ca3e,cb3e);
Vektor v17e=new Vektor(57.0,100.0,57.4);
p3e.add(v17e);
Vektor v18e=new Vektor(47.666666666667,100.0,57.4);
p3e.add(v18e);
Vektor v19e=new Vektor(47.66666670000001,100.0,47.4);
p3e.add(v19e);
Vektor v20e=new Vektor(57.0,100.0,47.4);
p3e.add(v20e);
p3e.setPaintGroup(pge);
g.add(p3e);

PaintGroup pgf=new PaintGroup();
Color ca1f=new Color(200,200,200);
Color cb1f=new Color(64,64,64);
Polygon p1f=new Polygon(ca1f,cb1f);
Vektor v1f=new Vektor(0.0,99.99,99.99);
p1f.add(v1f);
Vektor v2f=new Vektor(0.0,0.09999999999999432,99.99);
p1f.add(v2f);
Vektor v3f=new Vektor(0.0,0.09999999999999432,0.09999999999999432);
p1f.add(v3f);
Vektor v4f=new Vektor(0.0,99.99,0.09999999999999432);
p1f.add(v4f);
p1f.setPaintGroup(pgf);
g.add(p1f);
Color ca2f=new Color(0,0,255);
Color cb2f=new Color(100,0,200);
Polygon p2f=new Polygon(ca2f,cb2f);
Vektor v5f=new Vektor(0.0,47.333333333333336,62.666666666666664);
p2f.add(v5f);
Vektor v6f=new Vektor(0.0,88.666667,62.33334);
p2f.add(v6f);
Vektor v7f=new Vektor(0.0,88.66666670000001,57.66666666667);
p2f.add(v7f);
Vektor v8f=new Vektor(0.0,62.4,57.666667);
p2f.add(v8f);
Vektor v9f=new Vektor(0.0,62.4,10.366666666666674);
p2f.add(v9f);
Vektor v10f=new Vektor(0.0,57.666666666666664,10.370000000000005);
p2f.add(v10f);
Vektor v11f=new Vektor(0.0,57.666666666666664,42.333333333333336);
p2f.add(v11f);
Vektor v12f=new Vektor(0.0,10.333333333333329,42.333333333333336);
p2f.add(v12f);
Vektor v13f=new Vektor(0.0,10.333333333333329,47.0);
p2f.add(v13f);
Vektor v14f=new Vektor(0.0,42.33333334,47.0);
p2f.add(v14f);
Vektor v15f=new Vektor(0.0,42.333333333334,88.66666666666667);
p2f.add(v15f);
Vektor v16f=new Vektor(0.0,47.333333333333336,88.66666666666667);
p2f.add(v16f);
p2f.setPaintGroup(pgf);
g.add(p2f);
Color ca3f=new Color(200,200,200);
Color cb3f=new Color(200,200,200);
Polygon p3f=new Polygon(ca3f,cb3f);
Vektor v17f=new Vektor(0.0,57.0,57.4);
p3f.add(v17f);
Vektor v18f=new Vektor(0.0,47.666666666667,57.4);
p3f.add(v18f);
Vektor v19f=new Vektor(0.0,47.66666670000001,47.4);
p3f.add(v19f);
Vektor v20f=new Vektor(0.0,57.0,47.4);
p3f.add(v20f);
p3f.setPaintGroup(pgf);
g.add(p3f);

return g;
    }
    public static Group getPlayer1(){
Group g=new Group();
PaintGroup pg=new PaintGroup();
Color ca1=new Color(0,0,128);
Color cb1=new Color(128,64,0);
Polygon p1=new Polygon(ca1,cb1);
Vektor v1=new Vektor(0.3666666666666666,0.01,0.0);
p1.add(v1);
Vektor v2=new Vektor(99.93333333333332,0.0333333333333333,0.0);
p1.add(v2);
Vektor v3=new Vektor(99.96666666666667,99.83333333333333,0.0);
p1.add(v3);
Vektor v4=new Vektor(0.3333333333333333,99.66666666666667,0.0);
p1.add(v4);
p1.setPaintGroup(pg);
g.add(p1);
Color ca2=new Color(128,32,255);
Color cb2=new Color(200,200,200);
Polygon p2=new Polygon(ca2,cb2);
Vektor v5=new Vektor(90.0,90.0,0.0);
p2.add(v5);
Vektor v6=new Vektor(90.0,10.0,0.0);
p2.add(v6);
Vektor v7=new Vektor(10.0,10.0,0.0);
p2.add(v7);
Vektor v8=new Vektor(10.0,90.0,0.0);
p2.add(v8);
p2.setPaintGroup(pg);
g.add(p2);
Color ca3=new Color(255,255,32);
Color cb3=new Color(10,100,100);
Polygon p3=new Polygon(ca3,cb3);
Vektor v9=new Vektor(20.0,20.0,0.0);
p3.add(v9);
Vektor v10=new Vektor(50.0,80.0,0.0);
p3.add(v10);
Vektor v11=new Vektor(80.0,20.0,0.0);
p3.add(v11);
p3.setPaintGroup(pg);
g.add(p3);

PaintGroup pgb=new PaintGroup();
Color ca1b=new Color(0,0,128);
Color cb1b=new Color(128,64,0);
Polygon p1b=new Polygon(ca1b,cb1b);
Vektor v1b=new Vektor(0.3666666666666666,0.01,100.0);
p1b.add(v1b);
Vektor v2b=new Vektor(99.93333333333332,0.0333333333333333,100.0);
p1b.add(v2b);
Vektor v3b=new Vektor(99.96666666666667,99.83333333333333,100.0);
p1b.add(v3b);
Vektor v4b=new Vektor(0.3333333333333333,99.66666666666667,100.0);
p1b.add(v4b);
p1b.setPaintGroup(pgb);
g.add(p1b);
Color ca2b=new Color(128,32,255);
Color cb2b=new Color(200,200,200);
Polygon p2b=new Polygon(ca2b,cb2b);
Vektor v5b=new Vektor(90.0,90.0,100.0);
p2b.add(v5b);
Vektor v6b=new Vektor(90.0,10.0,100.0);
p2b.add(v6b);
Vektor v7b=new Vektor(10.0,10.0,100.0);
p2b.add(v7b);
Vektor v8b=new Vektor(10.0,90.0,100.0);
p2b.add(v8b);
p2b.setPaintGroup(pgb);
g.add(p2b);
Color ca3b=new Color(255,255,32);
Color cb3b=new Color(10,100,100);
Polygon p3b=new Polygon(ca3b,cb3b);
Vektor v9b=new Vektor(20.0,20.0,100.0);
p3b.add(v9b);
Vektor v10b=new Vektor(50.0,80.0,100.0);
p3b.add(v10b);
Vektor v11b=new Vektor(80.0,20.0,100.0);
p3b.add(v11b);
p3b.setPaintGroup(pgb);
g.add(p3b);

PaintGroup pgc=new PaintGroup();
Color ca1c=new Color(0,0,128);
Color cb1c=new Color(128,64,0);
Polygon p1c=new Polygon(ca1c,cb1c);
Vektor v1c=new Vektor(0.3666666666666666,0.0,99.99);
p1c.add(v1c);
Vektor v2c=new Vektor(99.93333333333332,0.0,99.96666666666667);
p1c.add(v2c);
Vektor v3c=new Vektor(99.96666666666667,0.0,0.1666666666666714);
p1c.add(v3c);
Vektor v4c=new Vektor(0.3333333333333333,0.0,0.3333333333333286);
p1c.add(v4c);
p1c.setPaintGroup(pgc);
g.add(p1c);
Color ca2c=new Color(128,32,255);
Color cb2c=new Color(200,200,200);
Polygon p2c=new Polygon(ca2c,cb2c);
Vektor v5c=new Vektor(90.0,0.0,10.0);
p2c.add(v5c);
Vektor v6c=new Vektor(90.0,0.0,90.0);
p2c.add(v6c);
Vektor v7c=new Vektor(10.0,0.0,90.0);
p2c.add(v7c);
Vektor v8c=new Vektor(10.0,0.0,10.0);
p2c.add(v8c);
p2c.setPaintGroup(pgc);
g.add(p2c);
Color ca3c=new Color(255,255,32);
Color cb3c=new Color(10,100,100);
Polygon p3c=new Polygon(ca3c,cb3c);
Vektor v9c=new Vektor(20.0,0.0,80.0);
p3c.add(v9c);
Vektor v10c=new Vektor(50.0,0.0,20.0);
p3c.add(v10c);
Vektor v11c=new Vektor(80.0,0.0,80.0);
p3c.add(v11c);
p3c.setPaintGroup(pgc);
g.add(p3c);

PaintGroup pgd=new PaintGroup();
Color ca1d=new Color(0,0,128);
Color cb1d=new Color(128,64,0);
Polygon p1d=new Polygon(ca1d,cb1d);
Vektor v1d=new Vektor(100.0,0.3666666666666666,99.99);
p1d.add(v1d);
Vektor v2d=new Vektor(100.0,99.93333333333332,99.96666666666667);
p1d.add(v2d);
Vektor v3d=new Vektor(100.0,99.96666666666667,0.1666666666666714);
p1d.add(v3d);
Vektor v4d=new Vektor(100.0,0.3333333333333333,0.3333333333333286);
p1d.add(v4d);
p1d.setPaintGroup(pgd);
g.add(p1d);
Color ca2d=new Color(128,32,255);
Color cb2d=new Color(200,200,200);
Polygon p2d=new Polygon(ca2d,cb2d);
Vektor v5d=new Vektor(100.0,90.0,10.0);
p2d.add(v5d);
Vektor v6d=new Vektor(100.0,90.0,90.0);
p2d.add(v6d);
Vektor v7d=new Vektor(100.0,10.0,90.0);
p2d.add(v7d);
Vektor v8d=new Vektor(100.0,10.0,10.0);
p2d.add(v8d);
p2d.setPaintGroup(pgd);
g.add(p2d);
Color ca3d=new Color(255,255,32);
Color cb3d=new Color(10,100,100);
Polygon p3d=new Polygon(ca3d,cb3d);
Vektor v9d=new Vektor(100.0,20.0,80.0);
p3d.add(v9d);
Vektor v10d=new Vektor(100.0,50.0,20.0);
p3d.add(v10d);
Vektor v11d=new Vektor(100.0,80.0,80.0);
p3d.add(v11d);
p3d.setPaintGroup(pgd);
g.add(p3d);

PaintGroup pge=new PaintGroup();
Color ca1e=new Color(0,0,128);
Color cb1e=new Color(128,64,0);
Polygon p1e=new Polygon(ca1e,cb1e);
Vektor v1e=new Vektor(99.63333333333334,100.0,99.99);
p1e.add(v1e);
Vektor v2e=new Vektor(0.06666666666667709,100.0,99.96666666666667);
p1e.add(v2e);
Vektor v3e=new Vektor(0.03333333333333144,100.0,0.1666666666666714);
p1e.add(v3e);
Vektor v4e=new Vektor(99.66666666666667,100.0,0.3333333333333286);
p1e.add(v4e);
p1e.setPaintGroup(pge);
g.add(p1e);
Color ca2e=new Color(128,32,255);
Color cb2e=new Color(200,200,200);
Polygon p2e=new Polygon(ca2e,cb2e);
Vektor v5e=new Vektor(10.0,100.0,10.0);
p2e.add(v5e);
Vektor v6e=new Vektor(10.0,100.0,90.0);
p2e.add(v6e);
Vektor v7e=new Vektor(90.0,100.0,90.0);
p2e.add(v7e);
Vektor v8e=new Vektor(90.0,100.0,10.0);
p2e.add(v8e);
p2e.setPaintGroup(pge);
g.add(p2e);
Color ca3e=new Color(255,255,32);
Color cb3e=new Color(10,100,100);
Polygon p3e=new Polygon(ca3e,cb3e);
Vektor v9e=new Vektor(80.0,100.0,80.0);
p3e.add(v9e);
Vektor v10e=new Vektor(50.0,100.0,20.0);
p3e.add(v10e);
Vektor v11e=new Vektor(20.0,100.0,80.0);
p3e.add(v11e);
p3e.setPaintGroup(pge);
g.add(p3e);

PaintGroup pgf=new PaintGroup();
Color ca1f=new Color(0,0,128);
Color cb1f=new Color(128,64,0);
Polygon p1f=new Polygon(ca1f,cb1f);
Vektor v1f=new Vektor(0.0,99.63333333333334,99.99);
p1f.add(v1f);
Vektor v2f=new Vektor(0.0,0.06666666666667709,99.96666666666667);
p1f.add(v2f);
Vektor v3f=new Vektor(0.0,0.03333333333333144,0.1666666666666714);
p1f.add(v3f);
Vektor v4f=new Vektor(0.0,99.66666666666667,0.3333333333333286);
p1f.add(v4f);
p1f.setPaintGroup(pgf);
g.add(p1f);
Color ca2f=new Color(128,32,255);
Color cb2f=new Color(200,200,200);
Polygon p2f=new Polygon(ca2f,cb2f);
Vektor v5f=new Vektor(0.0,10.0,10.0);
p2f.add(v5f);
Vektor v6f=new Vektor(0.0,10.0,90.0);
p2f.add(v6f);
Vektor v7f=new Vektor(0.0,90.0,90.0);
p2f.add(v7f);
Vektor v8f=new Vektor(0.0,90.0,10.0);
p2f.add(v8f);
p2f.setPaintGroup(pgf);
g.add(p2f);
Color ca3f=new Color(255,255,32);
Color cb3f=new Color(10,100,100);
Polygon p3f=new Polygon(ca3f,cb3f);
Vektor v9f=new Vektor(0.0,80.0,80.0);
p3f.add(v9f);
Vektor v10f=new Vektor(0.0,50.0,20.0);
p3f.add(v10f);
Vektor v11f=new Vektor(0.0,20.0,80.0);
p3f.add(v11f);
p3f.setPaintGroup(pgf);
g.add(p3f);
return g;
    }
    public static Group getPlayer2(){
Group g=new Group();
PaintGroup pg=new PaintGroup();
Color ca1=new Color(64,255,16);
Color cb1=new Color(255,255,128);
Polygon p1=new Polygon(ca1,cb1);
Vektor v1=new Vektor(0.01,0.01,0.0);
p1.add(v1);
Vektor v2=new Vektor(99.9,0.01,0.0);
p1.add(v2);
Vektor v3=new Vektor(99.9,99.9,0.0);
p1.add(v3);
Vektor v4=new Vektor(0.01,99.9,0.0);
p1.add(v4);
p1.setPaintGroup(pg);
g.add(p1);
Color ca2=new Color(32,255,128);
Color cb2=new Color(100,100,100);
Polygon p2=new Polygon(ca2,cb2);
Vektor v5=new Vektor(10.0,10.0,0.0);
p2.add(v5);
Vektor v6=new Vektor(90.0,10.0,0.0);
p2.add(v6);
Vektor v7=new Vektor(70.0,90.0,0.0);
p2.add(v7);
Vektor v8=new Vektor(30.0,90.0,0.0);
p2.add(v8);
p2.setPaintGroup(pg);
g.add(p2);
Color ca3=new Color(0,0,255);
Color cb3=new Color(0,0,0);
Polygon p3=new Polygon(ca3,cb3);
Vektor v9=new Vektor(30.0,20.0,0.0);
p3.add(v9);
Vektor v10=new Vektor(70.0,20.0,0.0);
p3.add(v10);
Vektor v11=new Vektor(55.00000000000001,75.0,0.0);
p3.add(v11);
Vektor v12=new Vektor(45.0,75.0,0.0);
p3.add(v12);
p3.setPaintGroup(pg);
g.add(p3);

PaintGroup pgb=new PaintGroup();
Color ca1b=new Color(64,255,16);
Color cb1b=new Color(255,255,128);
Polygon p1b=new Polygon(ca1b,cb1b);
Vektor v1b=new Vektor(0.01,0.01,100.0);
p1b.add(v1b);
Vektor v2b=new Vektor(99.9,0.01,100.0);
p1b.add(v2b);
Vektor v3b=new Vektor(99.9,99.9,100.0);
p1b.add(v3b);
Vektor v4b=new Vektor(0.01,99.9,100.0);
p1b.add(v4b);
p1b.setPaintGroup(pgb);
g.add(p1b);
Color ca2b=new Color(32,255,128);
Color cb2b=new Color(100,100,100);
Polygon p2b=new Polygon(ca2b,cb2b);
Vektor v5b=new Vektor(10.0,10.0,100.0);
p2b.add(v5b);
Vektor v6b=new Vektor(90.0,10.0,100.0);
p2b.add(v6b);
Vektor v7b=new Vektor(70.0,90.0,100.0);
p2b.add(v7b);
Vektor v8b=new Vektor(30.0,90.0,100.0);
p2b.add(v8b);
p2b.setPaintGroup(pgb);
g.add(p2b);
Color ca3b=new Color(0,0,255);
Color cb3b=new Color(0,0,0);
Polygon p3b=new Polygon(ca3b,cb3b);
Vektor v9b=new Vektor(30.0,20.0,100.0);
p3b.add(v9b);
Vektor v10b=new Vektor(70.0,20.0,100.0);
p3b.add(v10b);
Vektor v11b=new Vektor(55.00000000000001,75.0,100.0);
p3b.add(v11b);
Vektor v12b=new Vektor(45.0,75.0,100.0);
p3b.add(v12b);
p3b.setPaintGroup(pgb);
g.add(p3b);

PaintGroup pgc=new PaintGroup();
Color ca1c=new Color(64,255,16);
Color cb1c=new Color(255,255,128);
Polygon p1c=new Polygon(ca1c,cb1c);
Vektor v1c=new Vektor(0.01,0.0,99.99);
p1c.add(v1c);
Vektor v2c=new Vektor(99.9,0.0,99.99);
p1c.add(v2c);
Vektor v3c=new Vektor(99.9,0.0,0.09999999999999432);
p1c.add(v3c);
Vektor v4c=new Vektor(0.01,0.0,0.09999999999999432);
p1c.add(v4c);
p1c.setPaintGroup(pgc);
g.add(p1c);
Color ca2c=new Color(32,255,128);
Color cb2c=new Color(100,100,100);
Polygon p2c=new Polygon(ca2c,cb2c);
Vektor v5c=new Vektor(10.0,0.0,90.0);
p2c.add(v5c);
Vektor v6c=new Vektor(90.0,0.0,90.0);
p2c.add(v6c);
Vektor v7c=new Vektor(70.0,0.0,10.0);
p2c.add(v7c);
Vektor v8c=new Vektor(30.0,0.0,10.0);
p2c.add(v8c);
p2c.setPaintGroup(pgc);
g.add(p2c);
Color ca3c=new Color(0,0,255);
Color cb3c=new Color(0,0,0);
Polygon p3c=new Polygon(ca3c,cb3c);
Vektor v9c=new Vektor(30.0,0.0,80.0);
p3c.add(v9c);
Vektor v10c=new Vektor(70.0,0.0,80.0);
p3c.add(v10c);
Vektor v11c=new Vektor(55.00000000000001,0.0,25.0);
p3c.add(v11c);
Vektor v12c=new Vektor(45.0,0.0,25.0);
p3c.add(v12c);
p3c.setPaintGroup(pgc);
g.add(p3c);

PaintGroup pgd=new PaintGroup();
Color ca1d=new Color(64,255,16);
Color cb1d=new Color(255,255,128);
Polygon p1d=new Polygon(ca1d,cb1d);
Vektor v1d=new Vektor(100.0,0.01,99.99);
p1d.add(v1d);
Vektor v2d=new Vektor(100.0,99.9,99.99);
p1d.add(v2d);
Vektor v3d=new Vektor(100.0,99.9,0.09999999999999432);
p1d.add(v3d);
Vektor v4d=new Vektor(100.0,0.01,0.09999999999999432);
p1d.add(v4d);
p1d.setPaintGroup(pgd);
g.add(p1d);
Color ca2d=new Color(32,255,128);
Color cb2d=new Color(100,100,100);
Polygon p2d=new Polygon(ca2d,cb2d);
Vektor v5d=new Vektor(100.0,10.0,90.0);
p2d.add(v5d);
Vektor v6d=new Vektor(100.0,90.0,90.0);
p2d.add(v6d);
Vektor v7d=new Vektor(100.0,70.0,10.0);
p2d.add(v7d);
Vektor v8d=new Vektor(100.0,30.0,10.0);
p2d.add(v8d);
p2d.setPaintGroup(pgd);
g.add(p2d);
Color ca3d=new Color(0,0,255);
Color cb3d=new Color(0,0,0);
Polygon p3d=new Polygon(ca3d,cb3d);
Vektor v9d=new Vektor(100.0,30.0,80.0);
p3d.add(v9d);
Vektor v10d=new Vektor(100.0,70.0,80.0);
p3d.add(v10d);
Vektor v11d=new Vektor(100.0,55.00000000000001,25.0);
p3d.add(v11d);
Vektor v12d=new Vektor(100.0,45.0,25.0);
p3d.add(v12d);
p3d.setPaintGroup(pgd);
g.add(p3d);

PaintGroup pge=new PaintGroup();
Color ca1e=new Color(64,255,16);
Color cb1e=new Color(255,255,128);
Polygon p1e=new Polygon(ca1e,cb1e);
Vektor v1e=new Vektor(99.99,100.0,99.99);
p1e.add(v1e);
Vektor v2e=new Vektor(0.09999999999999432,100.0,99.99);
p1e.add(v2e);
Vektor v3e=new Vektor(0.09999999999999432,100.0,0.09999999999999432);
p1e.add(v3e);
Vektor v4e=new Vektor(99.99,100.0,0.09999999999999432);
p1e.add(v4e);
p1e.setPaintGroup(pge);
g.add(p1e);
Color ca2e=new Color(32,255,128);
Color cb2e=new Color(100,100,100);
Polygon p2e=new Polygon(ca2e,cb2e);
Vektor v5e=new Vektor(90.0,100.0,90.0);
p2e.add(v5e);
Vektor v6e=new Vektor(10.0,100.0,90.0);
p2e.add(v6e);
Vektor v7e=new Vektor(30.0,100.0,10.0);
p2e.add(v7e);
Vektor v8e=new Vektor(70.0,100.0,10.0);
p2e.add(v8e);
p2e.setPaintGroup(pge);
g.add(p2e);
Color ca3e=new Color(0,0,255);
Color cb3e=new Color(0,0,0);
Polygon p3e=new Polygon(ca3e,cb3e);
Vektor v9e=new Vektor(70.0,100.0,80.0);
p3e.add(v9e);
Vektor v10e=new Vektor(30.0,100.0,80.0);
p3e.add(v10e);
Vektor v11e=new Vektor(44.99999999999999,100.0,25.0);
p3e.add(v11e);
Vektor v12e=new Vektor(55.0,100.0,25.0);
p3e.add(v12e);
p3e.setPaintGroup(pge);
g.add(p3e);

PaintGroup pgf=new PaintGroup();
Color ca1f=new Color(64,255,16);
Color cb1f=new Color(255,255,128);
Polygon p1f=new Polygon(ca1f,cb1f);
Vektor v1f=new Vektor(0.0,99.99,99.99);
p1f.add(v1f);
Vektor v2f=new Vektor(0.0,0.09999999999999432,99.99);
p1f.add(v2f);
Vektor v3f=new Vektor(0.0,0.09999999999999432,0.09999999999999432);
p1f.add(v3f);
Vektor v4f=new Vektor(0.0,99.99,0.09999999999999432);
p1f.add(v4f);
p1f.setPaintGroup(pgf);
g.add(p1f);
Color ca2f=new Color(32,255,128);
Color cb2f=new Color(100,100,100);
Polygon p2f=new Polygon(ca2f,cb2f);
Vektor v5f=new Vektor(0.0,90.0,90.0);
p2f.add(v5f);
Vektor v6f=new Vektor(0.0,10.0,90.0);
p2f.add(v6f);
Vektor v7f=new Vektor(0.0,30.0,10.0);
p2f.add(v7f);
Vektor v8f=new Vektor(0.0,70.0,10.0);
p2f.add(v8f);
p2f.setPaintGroup(pgf);
g.add(p2f);
Color ca3f=new Color(0,0,255);
Color cb3f=new Color(0,0,0);
Polygon p3f=new Polygon(ca3f,cb3f);
Vektor v9f=new Vektor(0.0,70.0,80.0);
p3f.add(v9f);
Vektor v10f=new Vektor(0.0,30.0,80.0);
p3f.add(v10f);
Vektor v11f=new Vektor(0.0,44.99999999999999,25.0);
p3f.add(v11f);
Vektor v12f=new Vektor(0.0,55.0,25.0);
p3f.add(v12f);
p3f.setPaintGroup(pgf);
g.add(p3f);
return g;
    }
    public static Group getWorm1(){
        Group g=new Group();
        Color c=new Color(132,132,132);
        Color d=new Color(10,255,10);
        Color e=new Color(255,32,32);
        Vektor v1=new Vektor(50,40,50);
        Kugel k1=new Kugel(c,c,v1,10);
        Vektor v2=new Vektor(60,30,60);
        Kugel k2=new Kugel(d,d,v2,8);
        Vektor v3=new Vektor(60,50,60);
        Kugel k3=new Kugel(d,d,v3,8);
        Vektor v4=new Vektor(50,40,40);
        Kugel k4=new Kugel(e,e,v4,5);
        Vektor v5=new Vektor(50,40,35);
        Kugel k5=new Kugel(e,e,v5,5);
        Vektor v6=new Vektor(50,40,30);
        Kugel k6=new Kugel(e,e,v6,5);
        Vektor v7=new Vektor(50,40,25);
        Kugel k7=new Kugel(e,e,v7,5);
        Vektor v8=new Vektor(50,40,20);
        Kugel k8=new Kugel(e,e,v8,5);
        Vektor v9=new Vektor(45,40,15);
        Kugel k9=new Kugel(e,e,v9,5);
        Vektor v10=new Vektor(40,40,10);
        Kugel k10=new Kugel(e,e,v10,5);
        Vektor v11=new Vektor(35,40,5);
        Kugel k11=new Kugel(e,e,v11,5);
        Vektor v12=new Vektor(30,40,5);
        Kugel k12=new Kugel(e,e,v12,5);
        Vektor v13=new Vektor(25,40,5);
        Kugel k13=new Kugel(e,e,v13,5);
        g.add(k1);
        g.add(k2);
        g.add(k3);
        g.add(k4);
        g.add(k5);
        g.add(k6);
        g.add(k7);
        g.add(k8);
        g.add(k9);
        g.add(k10);
        g.add(k11);
        g.add(k12);
        g.add(k13);
        return g;
    }
    public static Group getWorm2(){
        Group g=new Group();
        Color c=new Color(255,0,32);
        Color d=new Color(32,32,255);
        Color e=new Color(255,32,32);
        Vektor v1=new Vektor(50,40,50);
        Kugel k1=new Kugel(c,c,v1,10);
        Vektor v2=new Vektor(60,30,60);
        Kugel k2=new Kugel(d,d,v2,8);
        Vektor v3=new Vektor(60,50,60);
        Kugel k3=new Kugel(d,d,v3,8);
        Vektor v4=new Vektor(50,40,40);
        Kugel k4=new Kugel(e,e,v4,5);
        Vektor v5=new Vektor(50,40,35);
        Kugel k5=new Kugel(e,e,v5,5);
        Vektor v6=new Vektor(50,40,30);
        Kugel k6=new Kugel(e,e,v6,5);
        Vektor v7=new Vektor(50,40,25);
        Kugel k7=new Kugel(e,e,v7,5);
        Vektor v8=new Vektor(50,40,20);
        Kugel k8=new Kugel(e,e,v8,5);
        Vektor v9=new Vektor(45,40,15);
        Kugel k9=new Kugel(e,e,v9,5);
        Vektor v10=new Vektor(40,40,10);
        Kugel k10=new Kugel(e,e,v10,5);
        Vektor v11=new Vektor(35,40,5);
        Kugel k11=new Kugel(e,e,v11,5);
        Vektor v12=new Vektor(30,40,5);
        Kugel k12=new Kugel(e,e,v12,5);
        Vektor v13=new Vektor(25,40,5);
        Kugel k13=new Kugel(e,e,v13,5);
        g.add(k1);
        g.add(k2);
        g.add(k3);
        g.add(k4);
        g.add(k5);
        g.add(k6);
        g.add(k7);
        g.add(k8);
        g.add(k9);
        g.add(k10);
        g.add(k11);
        g.add(k12);
        g.add(k13);
        return g;
    }
    public static Group getCannon1(){
        Group g=new Group();
        Color c=new Color(128,128,128);
        for(int i=0;i<9;i++){
            Vektor v1=new Vektor(50+(i-4)*5,60,50);
            Kugel k=new Kugel(c,c,v1,5);
            g.add(k);
        }
        return g;
    }
    public static Group getCannon2(){
        Group g=new Group();
        Color c=new Color(64,64,64);
        for(int i=0;i<9;i++){
            Vektor v1=new Vektor(50+(i-4)*5,60,50);
            Kugel k=new Kugel(c,c,v1,5);
            g.add(k);
        }
        return g;
    }
    public static Group getExplosion(Color c){
        Group g=new Group();
        Vektor v1=new Vektor(0,0,0);
        Vektor v2=new Vektor(100,0,0);
        Vektor v3=new Vektor(100,100,0);
        Vektor v4=new Vektor(0,100,0);
        Quad q1=new Quad(c,Color.black,v1,v2,v3,v4);
        g.add(q1);
        Vektor v5=new Vektor(0,0,100);
        Vektor v6=new Vektor(100,0,100);
        Vektor v7=new Vektor(100,100,100);
        Vektor v8=new Vektor(0,100,100);
        Quad q2=new Quad(c,Color.black,v5,v6,v7,v8);
        g.add(q2);
        Vektor v9=new Vektor(0,0,100);
        Vektor v10=new Vektor(100,0,100);
        Vektor v11=new Vektor(100,0,0);
        Vektor v12=new Vektor(0,0,0);
        Quad q3=new Quad(c,Color.black,v9,v10,v11,v12);
        g.add(q3);
        Vektor v13=new Vektor(0,100,100);
        Vektor v14=new Vektor(100,100,100);
        Vektor v15=new Vektor(100,100,0);
        Vektor v16=new Vektor(0,100,0);
        Quad q4=new Quad(c,Color.black,v13,v14,v15,v16);
        g.add(q4);
        Vektor v17=new Vektor(0,0,100);
        Vektor v18=new Vektor(0,100,100);
        Vektor v19=new Vektor(0,100,0);
        Vektor v20=new Vektor(0,0,0);
        Quad q5=new Quad(c,Color.black,v17,v18,v19,v20);
        g.add(q5);
        Vektor v21=new Vektor(100,0,100);
        Vektor v22=new Vektor(100,100,100);
        Vektor v23=new Vektor(100,100,0);
        Vektor v24=new Vektor(100,0,0);
        Quad q6=new Quad(c,Color.black,v21,v22,v23,v24);
        g.add(q6);
        return g;
    }
}
class Worm{
    int x;
    int y;
    int z;
    int owner;
    double anglex;
    double angley;
    double alpha;
    double beta;
    double alphab;
    double betab;
    double xdiff;
    double ydiff;
    boolean camera=false;
    boolean inverse=false;
    boolean inverseb=false;
    double xbase;
    double ybase;
    double zbase;
    double xdrift;
    double ydrift;
    double zdrift;
    double t;
    double pulver=10;
    public Worm(int owner){
        this.owner=owner;
    }
}
class CubeRunner implements Runnable{
    Thread t;
    Cubewar2009 cw;
    int actionnr=0;
    public CubeRunner(Cubewar2009 cw){
        this.cw=cw;
        t=new Thread(this);
        t.start();
    }
    public void run(){
        if(cw.player!=0){
            new CubeReader(cw);
        }
        while(true){
            try{
                if(actionnr!=0){
                    int a=actionnr;
                    actionnr=0;
                    boolean ok=true;
                    boolean special=false;
                    if(cw.player==1){
                        if((cw.state>2&&cw.state<10)||cw.state>=10){
                            ok=false;
                        }
                        if(cw.state==3||cw.state==13){
                            special=true;
                        }
                    }
                    if(cw.player==2){
                        if((cw.state>12&&cw.state<20)||cw.state<10){
                            ok=false;
                        }
                        if(cw.state==3||cw.state==13){
                            special=true;
                        }
                    }
                    if(special||ok){
                        cw.action(a);
                    }
                    if(cw.player!=0&&ok){
                        cw.ps.println(""+a);
                    }
                }
                Thread.sleep(10);
            }
            catch(Exception e){
            }
        }
    }
}
class CubeReader implements Runnable{
    Cubewar2009 cw;
    Thread t;
    public CubeReader(Cubewar2009 cw){
        this.cw=cw;
        t=new Thread(this);
        t.start();
    }
    public void run(){
        try{
            String inp="";
            while((inp=cw.dis.readLine())!=null){
                int nr=new Integer(inp).intValue();
                if(nr>0&&nr<7){
                    if(cw.player==1){
                        while(cw.state<10||cw.state>12){
                        }
                    }
                    if(cw.player==2){
                        while(cw.state<0||cw.state>2){
                        }
                    }
                    cw.action(nr);
                }
            }
        }
        catch(Exception e){
        }
    }
}
class EngineCubeMain extends Canvas{
    Thread t;
    ImageFrameCubeMain imf;
    Image img;
    Graphics h;
    Polygon start;
    Polygon end;
    PaintGroup pgstart;
    PaintGroup pgend;
    String status="astrosolutions.de";
    boolean first=true;
    boolean ison=false;
    Graphics paintg;
    boolean inverse=false;
    Veks[]v;
    double winkel=Math.PI/4;
    int grenze=10;
    int countero=0;
    private static final long serialVersionUID = 5121106118940991253L;
    public EngineCubeMain(){
        imf=new ImageFrameCubeMain();
        img=imf.img;
        h=img.getGraphics();
//        t=new Thread(this);
//        t.start();
    }
    public synchronized void setOn(){
        first=false;
        ison=true;
    }
    public synchronized void setOff(){
        ison=false;
    }
    public synchronized void setInverseOn(){
        inverse=true;
    }
    public synchronized void setInverseOff(){
        inverse=false;
    }
    public void loadVeks(){
        try{
            InputStream fis=CubeMain.getInputStream("stg");
            DataInputStream dis=new DataInputStream(fis);
            while(dis.readLine()!=null)countero++;
            dis.close();
            fis.close();
            countero=countero/4;
            v=new Veks[countero];
            InputStream fisz=CubeMain.getInputStream("stg");
            DataInputStream disz=new DataInputStream(fisz);
            for(int i=0;i<countero;i++){
                double x=new Double(disz.readLine()).doubleValue();
                double y=new Double(disz.readLine()).doubleValue();
                double z=new Double(disz.readLine()).doubleValue();
                int m=new Integer(disz.readLine()).intValue();
                v[i]=new Veks(x,y,z,m);
            }
            disz.close();
            fisz.close();
        }
        catch(Exception e){System.out.println(e);};
    }
    public synchronized void run(){
        boolean running=true;
//        try{
//            while(running){
//                Thread.sleep(100);
//                repaint();
//            }
//        }
//        catch(Exception e){
//        }
    }
    public synchronized void setNotProcessed(){
        Polygon cur=start;
        while(cur!=null){
            if(cur.pg!=null){
                cur.pg.setNotProcessed();
            }
            cur=cur.next;
        }
    }
    public synchronized void remove(Polygon poly){
        Polygon fore=null;
        Polygon cur=start;
        while(cur!=null){
            if(cur==poly){
                if(cur.pg!=null){
                    cur.pg.remove(cur);
                    cur.pg=null;
                }
                if(fore==null){
                    start=cur.next;
                }
                if(cur.next==null){
                    end=fore;
                }
                if(fore!=null){
                    fore.next=cur.next;
                }
            }
            fore=cur;
            cur=cur.next;
        }
    }
    public synchronized void remove(Group g){
        Polygon cur=g.start;
        while(cur!=null){
            remove(cur);
            cur=cur.grnext;
        }
    }
    public synchronized void move(){
        Polygon cur=start;
        while(cur!=null){
            cur.move();
            cur=cur.next;
        }
    }
    public synchronized void rotUp(double w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotUp(w);
            cur=cur.next;
        }
    }
    public synchronized void rotLeft(double w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotLeft(w);
            cur=cur.next;
        }
    }
    public synchronized void transform(double a,double b,double c){
        Polygon cur=start;
        while(cur!=null){
            cur.transform(a,b,c);
            cur=cur.next;
        }
    }
    public synchronized void getPaintGroups(){
        pgstart=null;
        pgend=null;
        Polygon cur=start;
        while(cur!=null){
            if(cur.pg==null){
                cur.pg=new PaintGroup();
                cur.pg.add(cur);
                cur.pg.setProcessed();
                addPaintGroup(cur.pg);
            }
            else{
                if(!cur.pg.processed){
                    addPaintGroup(cur.pg);
                    cur.pg.setProcessed();
                }
            }
            cur=cur.next;
        }
    }
    public synchronized void addPaintGroup(PaintGroup pg){
        if(pgstart==null){
            pgstart=pg;
            pgend=pg;
        }
        else{
            pgend.next=pg;
            pgend=pgend.next;
        }
    }
    public synchronized void add(Polygon p){
        p.next=null;
        if(start==null){
            start=p;
            end=p;
        }
        else{
            end.next=p;
            end=end.next;
        }
    }
    public synchronized void add(Group group){
        Polygon cur=group.start;
        while(cur!=null){
            add(cur);
            cur=cur.grnext;
        }
    }
    public static void sort(PaintGroup[]a,int l,int r){
//Quicksort sortiert PaintGroups nach entf-Werten
        if(l>=r){
            return;
        }
        PaintGroup[]part=new PaintGroup[r-l+1];
        PaintGroup[]partm=new PaintGroup[r-l+1];
        int middle=(l+r)/2;
        double middlevalue=a[middle].entf;
        int i=0;
        int j=r-l;
        int m=0;
        for(int k=l;k<=r;k++){
            if(a[k].entf<middlevalue){
                part[i]=a[k];
                i++;
            }
            else if(a[k].entf>middlevalue){
                part[j]=a[k];
                j--;
            }
            else{
                partm[m]=a[k];
                m++;
            }
        }
        for(int k=0;k<i;k++){
            a[k+l]=part[k];
        }
        for(int k=0;k<m;k++){
            a[i+k+l]=partm[k];
        }
        for(int k=r-l;k>j;k--){
            a[k+l]=part[k];
        }
        sort(a,l,i-1+l);
        sort(a,j+1+l,r);
    }
    public synchronized Vektor getCoord(Vektor v){
        double x=v.xb;
        double y=v.yb;
        double z=v.zb;
        double vx=Math.atan(y/x)/(Math.PI/6)*200;
        double vy=Math.atan(z/x)/(Math.PI/6)*200;
        double vz=x;
        Vektor rvv=new Vektor(vx,vy,vz);
        return rvv;
    }
    public void paint(Graphics g){
//        if(first){
//            return;
//        }
    }
    public void rotLeft2(double schieb){
        for(int j=0;j<countero;j++){
            double dax=v[j].x;
            double day=v[j].z;
            double win=Math.atan(day/dax);
            if(dax<0)win=win+Math.PI;
            if(win<0)win=2*Math.PI+win;
            win=win-schieb;
            double len=Math.sqrt(dax*dax+day*day);
            v[j].x=(Math.cos(win))*len;
            v[j].z=(Math.sin(win))*len;
        }
    }
    public void rotUp2(double schieb){
        for(int j=0;j<countero;j++){
            double dax=v[j].y;
            double day=v[j].z;
            double win=Math.atan(day/dax);
            if(dax<0)win=win+Math.PI;
            if(win<0)win=2*Math.PI+win;
            win=win-schieb;
            double len=Math.sqrt(dax*dax+day*day);
            v[j].y=(Math.cos(win))*len;
            v[j].z=(Math.sin(win))*len;
        }
    }
    public synchronized void update(Graphics g){
        if(first){
            return;
        }
        if(!ison){
            if(paintg!=null){
//                paint(paintg);
                return;
            }
        }
        h.setColor(Color.black);
        h.fillRect(0,0,800,600);
        h.setColor(Color.white);
        for(int i=0;i<countero;i++){
            if(v[i].z>0){
                double alpha=Math.atan(v[i].x/v[i].z);
                double beta=Math.atan(v[i].y/v[i].z);
                int qx=(int)(alpha/winkel*200.0);
                int qy=(int)(beta/winkel*200.0);
                if(Math.abs(qx)<200&&Math.abs(qy)<200){
                    int size=(5-v[i].m);
                    if(v[i].m<=grenze){
                        h.fillOval(200+qx-(size/2),240+qy-(size/2),size,size);
                    }
                }
            }
        }
        setNotProcessed();
        getPaintGroups();
        PaintGroup pgcur=pgstart;
        int count=0;
        while(pgcur!=null){
            pgcur.getEntf();
            pgcur=pgcur.next;
            count++;
        }
        pgcur=pgstart;
        PaintGroup[]pgs=new PaintGroup[count];
        for(int i=0;i<count;i++){
            pgs[i]=pgcur;
            pgcur=pgcur.next;
        }
        sort(pgs,0,pgs.length-1);
        for(int i=pgs.length-1;i>=0;i--){
            Polygon pol=pgs[i].start;
            while(pol!=null){
                Vektor point=pol.start;
                if(pol.kugel){
                    Vektor kv=getCoord(point);
                    if(kv.z>0){
                        double winkel=Math.atan(pol.radius/pgs[i].entf);
                        int len=(int)((winkel/(Math.PI/6))*200)*2;
                        h.setColor(pol.col);
                        if(!inverse){
                            h.fillOval(200-(len/2)+((int)kv.x),200-(len/2)-((int)kv.y),len,len);
                        }
                        else{
                            h.fillOval(200-(len/2)+((int)kv.x),200+(len/2)-((int)kv.y),len,len);
                        }
                    }
                }
                else{
                    java.awt.Polygon pogy=new java.awt.Polygon();
                    boolean seen=true;
                    while(point!=null){
                        Vektor veci=getCoord(point);
                        if(veci.z<=0){
                            seen=false;
                        }
                        if(!inverse){
                            pogy.addPoint((int)(200+veci.x),(int)(200-veci.y));
                        }
                        else{
                            pogy.addPoint((int)(200+veci.x),(int)(200+veci.y));
                        }
                        point=point.next;
                    }
                    if(seen){
                        h.setColor(pol.col);
                        h.fillPolygon(pogy);
                        if(pol.col!=pol.rcol){
                            h.setColor(pol.rcol);
                            h.drawPolygon(pogy);
                        }
                    }
                }
                pol=pol.gnext;
            }
        }
        h.setColor(Color.blue);
        h.drawString(status,10,90);
        g.drawImage(img,0,0,this);
        paintg=g;
        paint(g);
    }
    public synchronized void setStatus(String status){
        this.status=status;
    }
}
class PaintGroup{
    PaintGroup next;
    Polygon start;
    Polygon end;
    boolean processed=false;
    double entf=0;
    public PaintGroup(){
    }
    public void getEntf(){
        entf=entf();
    }
    public void setProcessed(){
        processed=true;
    }
    public void setNotProcessed(){
        processed=false;
    }
    public void reset(){
        start=null;
        end=null;
    }
    public void remove(Polygon poly){
        Polygon fore=null;
        Polygon cur=start;
        while(cur!=null){
            if(cur==poly){
                if(fore==null){
                    start=cur.gnext;
                }
                if(cur.gnext==null){
                    end=fore;
                }
                if(fore!=null){
                    fore.gnext=cur.gnext;
                }
            }
            fore=cur;
            cur=cur.gnext;
        }
    }
    public void add(Polygon p){
        if(start==null){
            start=p;
            end=p;
        }
        else{
            end.gnext=p;
            end=end.gnext;
        }
    }
    public double entf(){
        int count=0;
        Polygon cur=start;
        Vektor sum=new Vektor(0,0,0);
        while(cur!=null){
            Vektor cur2=cur.start;
            while(cur2!=null){
                sum.transform(cur2.getXb(),cur2.getYb(),cur2.getZb());
                cur2=cur2.next;
                count++;
            }
            cur=cur.gnext;
        }
        Vektor ret=new Vektor(sum.x/count,sum.y/count,sum.z/count);
        return ret.entf();
    }
}
class Group{
    Polygon start;
    Polygon end;
    public Group cloneo(){
        Group group=new Group();
        Polygon cur=start;
        while(cur!=null){
            group.add(cur.cloneo());
            cur=cur.grnext;
        }
        return group;
    }
    public void change(Color a,Color b){
        Polygon cur=start;
        while(cur!=null){
            cur.change(a,b);
            cur=cur.grnext;
        }
    }
    public void add(Polygon p){
        if(start==null){
            start=p;
            end=p;
        }
        else{
            end.grnext=p;
            end=end.grnext;
        }
    }
    public void move(){
        Polygon cur=start;
        while(cur!=null){
            cur.move();
            cur=cur.grnext;
        }
    }
    public void rotUp(double w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotUp(w);
            cur=cur.grnext;
        }
    }
    public void rotLeft(double w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotLeft(w);
            cur=cur.grnext;
        }
    }
    public void transform(double a,double b,double c){
        Polygon cur=start;
        while(cur!=null){
            cur.transform(a,b,c);
            cur=cur.grnext;
        }
    }
}
class Kugel extends Polygon{
    public Kugel(Color col,Color rcol,Vektor v,double radius){
        super(col,rcol);
        add(v);
        this.radius=radius;
        this.kugel=true;
    }
    public Vektor getCenter(){
        return start;
    }
}
class Quad extends Polygon{
    public Quad(Color col,Color rcol,Vektor v1,Vektor v2,Vektor v3,Vektor v4){
        super(col,rcol);
        add(v1);
        add(v2);
        add(v3);
        add(v4);
    }
    public Vektor getV1(){
        return start;
    }
    public Vektor getV2(){
        return start.next;
    }
    public Vektor getV3(){
        return start.next.next;
    }
    public Vektor getV4(){
        return start.next.next.next;
    }
}
class Triangle extends Polygon{
    public Triangle(Color col,Color rcol,Vektor v1,Vektor v2,Vektor v3){
        super(col,rcol);
        add(v1);
        add(v2);
        add(v3);
    }
    public Vektor getV1(){
        return start;
    }
    public Vektor getV2(){
        return start.next;
    }
    public Vektor getV3(){
        return start.next.next;
    }
}
class Polygon{
    Polygon next;
    Polygon gnext;
    Polygon grnext;
    PaintGroup pg;
    Vektor start;
    Vektor end;
    Color col;
    Color rcol;
    boolean kugel=false;
    double radius=0;
    boolean processed=false;
    double entf=0;
    public Polygon(Color col,Color rcol){
        this.col=col;
        this.rcol=rcol;
    }
    public void change(Color a,Color b){
        if(col.equals(a)){
            col=b;
        }
    }
    public Polygon cloneo(){
        Polygon ret=new Polygon(col,rcol);
        ret.kugel=kugel;
        ret.radius=radius;
        ret.processed=processed;
        ret.entf=entf;
        Vektor cur=start;
        while(cur!=null){
            ret.add(cur.cloneo());
            cur=cur.next;
        }
        return ret;
    }
    public void setProcessed(){
        processed=true;
    }
    public void setNotProcessed(){
        processed=false;
    }
    public void setPaintGroup(PaintGroup pg){
        this.pg=pg;
        pg.add(this);
    }
    public void add(Vektor v){
        if(start==null){
            start=v;
            end=v;
        }
        else{
            end.next=v;
            end=end.next;
        }
    }
    public void move(){
        Vektor cur=start;
        while(cur!=null){
            cur.move();
            cur=cur.next;
        }
    }
    public void rotUp(double w){
        Vektor cur=start;
        while(cur!=null){
            cur.rotUp(w);
            cur=cur.next;
        }
    }
    public void rotLeft(double w){
        Vektor cur=start;
        while(cur!=null){
            cur.rotLeft(w);
            cur=cur.next;
        }
    }
    public double entf(){
        int count=0;
        Vektor cur=start;
        Vektor sum=new Vektor(0,0,0);
        while(cur!=null){
            sum.transform(cur.getX(),cur.getY(),cur.getZ());
            cur=cur.next;
            count++;
        }
        Vektor ret=new Vektor(sum.x/count,sum.y/count,sum.z/count);
        return ret.entf();
    }
    public void transform(double a,double b,double c){
        Vektor cur=start;
        while(cur!=null){
            cur.transform(a,b,c);
            cur=cur.next;
        }
    }
}
class ImageFrameCubeMain extends Frame{
    Image img;
    private static final long serialVersionUID = 1737999475651880841L;
    public ImageFrameCubeMain(){
        pack();
        img=createImage(800,600);
    }
}
class Vektor{
    double x,y,z;
    double xb,yb,zb;
    double xtra;
    Vektor next;
    public Vektor(double x,double y,double z){
        this.x=x;
        this.y=y;
        this.z=z;
    }
    public void print(){
        System.out.println("x: "+x+" y: "+y+" z: "+z);
    }
    public double getX(){
        return x;
    }
    public double getY(){
        return y;
    }
    public double getZ(){
        return z;
    }
    public double getXb(){
        return xb;
    }
    public double getYb(){
        return yb;
    }
    public double getZb(){
        return zb;
    }
    public double getXtra(){
        return xtra;
    }
    public Vektor cloneo(){
        Vektor cl=new Vektor(x,y,z);
        cl.xb=xb;
        cl.yb=yb;
        cl.zb=zb;
        cl.xtra=xtra;
        return cl;
    }
    public void move(){
        xb=x;
        yb=y;
        zb=z;
    }
    public void transform(double a,double b,double c){
        x+=a;
        y+=b;
        z+=c;
    }
    public void setCoord(int coord,double a){
        if(coord==1)x=a;
        else if(coord==2)y=a;
        else if(coord==2)z=a;
    }
    public void changeCoord(int coord1,int coord2){
        double temp=0;
        if((coord1==1&&coord2==2)||(coord1==2&&coord2==1)){
            temp=x;
            x=y;
            y=temp;
        }
        if((coord1==1&&coord2==3)||(coord1==3&&coord2==1)){
            temp=x;
            x=z;
            z=temp;
        }
        if((coord1==2&&coord2==3)||(coord1==3&&coord2==1)){
            temp=y;
            y=z;
            z=temp;
        }
    }
    public double entf(){
        return Math.sqrt(x*x+y*y+z*z);
    }
    public void rotLeft(double w){
        double win=0;
        if(x==0){
            if(y>0)win=Math.PI/2;
            else win=-Math.PI/2;
        }
        else{
            win=Math.atan(y/x);
        }
        if(x<0)win+=Math.PI;
        double len=Math.sqrt(x*x+y*y);
        win+=w;
        x=Math.cos(win)*len;
        y=Math.sin(win)*len;
    }
    public void rotUp(double w){
        double win=0;
        if(x==0){
            if(z>0)win=Math.PI/2;
            else win=-Math.PI/2;
        }
        else{
            win=Math.atan(z/x);
        }
        if(x<0)win+=Math.PI;
        double len=Math.sqrt(x*x+z*z);
        win+=w;
        x=Math.cos(win)*len;
        z=Math.sin(win)*len;
    }
}
class Veks{
    double x,y,z;
    int m;
    public Veks(double a,double b,double c,int d){
        x=a;
        y=b;
        z=c;
        m=d;
    }
}
