import java.awt.*;
import java.io.*;
class SpaceBomber extends Frame{
    Label l;
    SpaceCanvas sc;
    public SpaceBomber(boolean b){
        super("Astro Solutions Space Bomber");
        pack();
        resize(400,440);
        l=new Label();
        sc=new SpaceCanvas();
        add(sc);
        add(l);
        sc.reshape(0,0,400,440);
        show();
        if(b){
            PDialog pd=new PDialog(this);
            pd.show();
        }
        else sc.start();
    }
    public boolean handleEvent(Event evt){
        if(evt.id==Event.WINDOW_DESTROY)System.exit(0);
        if(evt.id==Event.KEY_PRESS||evt.id==Event.KEY_ACTION){
            if(evt.key==Event.LEFT){
                sc.rotl(Math.PI/45);
            }
            if(evt.key==Event.RIGHT){
                sc.rotl(-Math.PI/45);
            }
            if(evt.key==Event.UP){
                sc.rotu(Math.PI/45);
            }
            if(evt.key==Event.DOWN){
                sc.rotu(-Math.PI/45);
            }
            if(evt.key==Event.ENTER){
                hide();
                new SpaceBomber(false);
            }
            if(evt.key==Event.DELETE){
                sc.newShot();
            }
        }
        return false;
    }
    public static void main(String[]args){
        new SpaceBomber(true);
    }
}
class ImageFrame extends Frame{
    Image img;
    public ImageFrame(){
        pack();
        img=createImage(800,600);
    }
}
class ZDpoint{
    int x;
    int y;
    public ZDpoint(int x,int y){
        this.x=x;
        this.y=y;
    }
    public void shift(){
        x+=3;
        y+=2;
    }
}
class SpaceCanvas extends Canvas implements Runnable{
    Ball[] boules=new Ball[1000];
    double oob=1600;
    Thread t;
    Image img;
    Graphics h;
    boolean halted=false;
    int cits;
    int countero;
    int grenze=10;
    Veks[]v;
    double winkel=Math.PI/4;
    ZDpoint[]zd=new ZDpoint[100];
    Vector[] kug=new Vector[1000];
    Vector[] kugdir=new Vector[1000];
    public SpaceCanvas(){
        for(int i=0;i<100;i++){
            zd[i]=new ZDpoint((int)(Math.random()*400),(int)(Math.random()*400));
        }
        boules[0]=new Ball(25,25,50,0);
        boulestranslate(200,0,0);
        t=new Thread(this);
        ImageFrame ifr=new ImageFrame();
        img=ifr.img;
        h=img.getGraphics();
        loadVeks();
    }
    public void start(){
        t.start();
    }
    public void run(){
        while(true){
            try{
                Thread.sleep(100);
                repaint();
            }
            catch(Exception e){};
            if(halted)break;
        }
    }
    public void paint(Graphics g){
    }
    public void newShot(){
        for(int i=0;i<1000;i++){
            boolean b=false;
            if(kug[i]==null){
                kug[i]=new Vector(10,0,0);
                kugdir[i]=new Vector(6,0,0);
                b=true;
            }
            if(b)break;
        }
    }
    public void rotl(double rot){
        rotLeft2(rot);
        for(int i=0;i<1000;i++){
            if(boules[i]!=null)boules[i].rotRight(rot);
        }
        for(int i=0;i<1000;i++){
            if(kug[i]!=null)kug[i].rotRight(rot);
            if(kugdir[i]!=null)kugdir[i].rotRight(rot);
        }
    }
    public void rotu(double rot){
        rotUp2(rot);
        for(int i=0;i<1000;i++){
            if(boules[i]!=null)boules[i].rotDown(rot);
        }
        for(int i=0;i<1000;i++){
            if(kug[i]!=null)kug[i].rotDown(rot);
            if(kugdir[i]!=null)kugdir[i].rotDown(rot);
        }
    }
    public void boulestranslate(double x,double y,double z){
        for(int i=0;i<1000;i++){
            if(boules[i]!=null)boules[i].translate(x,y,z);
        }
        for(int i=0;i<1000;i++){
            if(kug[i]!=null)kug[i].translate(x,y,z);
        }
    }

    public void loadVeks(){
        try{
            FileInputStream fis=new FileInputStream("stg");
            DataInputStream dis=new DataInputStream(fis);
            while(dis.readLine()!=null)countero++;
            dis.close();
            fis.close();
            countero=countero/4;
            v=new Veks[countero];
            FileInputStream fisz=new FileInputStream("stg");
            DataInputStream disz=new DataInputStream(fisz);
            for(int i=0;i<countero;i++){
                double x=new Double(disz.readLine()).doubleValue();
                double y=new Double(disz.readLine()).doubleValue();
                double z=new Double(disz.readLine()).doubleValue();
                int m=new Integer(disz.readLine()).intValue();
                v[i]=new Veks(x,y,z,m);
            }
            disz.close();
            fisz.close();
        }
        catch(Exception e){System.out.println(e);};
    }

    public void rotLeft2(double schieb){
        for(int j=0;j<countero;j++){
            double dax=v[j].x;
            double day=v[j].z;
            double win=Math.atan(day/dax);
            if(dax<0)win=win+Math.PI;
            if(win<0)win=2*Math.PI+win;
            win=win-schieb;
            double len=Math.sqrt(dax*dax+day*day);
            v[j].x=(Math.cos(win))*len;
            v[j].z=(Math.sin(win))*len;
        }
    }
    public void rotUp2(double schieb){
        for(int j=0;j<countero;j++){
            double dax=v[j].y;
            double day=v[j].z;
            double win=Math.atan(day/dax);
            if(dax<0)win=win+Math.PI;
            if(win<0)win=2*Math.PI+win;
            win=win-schieb;
            double len=Math.sqrt(dax*dax+day*day);
            v[j].y=(Math.cos(win))*len;
            v[j].z=(Math.sin(win))*len;
        }
    }

    public void newBall(){
        for(int i=0;i<1000;i++){
            boolean brea=false;
            if(boules[i]==null){
                int a=(int)(Math.random()*20+20);
                int b=(int)(Math.random()*20+20);
                int c=(int)(Math.random()*20+20);
                boules[i]=new Ball(a,b,c,0);
                boules[i].linksrot=Math.random()*Math.PI/16-Math.PI/32;
                boules[i].untenrot=Math.random()*Math.PI/16-Math.PI/32;
                double xpo=0;
                while(xpo<7*oob/10)xpo=Math.random()*9*oob/10;
                double ypo=Math.random()*3*oob/10;
                double zpo=Math.random()*3*oob/10;
                boules[i].flugdir=new Vector(xpo/(oob/20),ypo/(oob/20),zpo/(oob/20));
                boules[i].translate(oob/10+xpo,ypo,zpo);
                brea=true;
            }
            if(brea)break;
        }
    }

    public void update(Graphics g){
        h.setColor(Color.black);
        h.fillRect(0,0,500,500);
        h.setColor(Color.white);
        h.drawString("Balls "+(cits),100,80);

        if(((int)(Math.random()*30))==0)newBall();

        for(int i=0;i<1000;i++){
            if(boules[i]!=null){
                boules[i].translate(-boules[i].flugdir.x,-boules[i].flugdir.y,-boules[i].flugdir.z);
                boules[i].downturn(boules[i].untenrot);
                boules[i].leftturn(boules[i].linksrot);
            }
        }
        for(int i=0;i<1000;i++){
            if(boules[i]!=null&&boules[i].fading){
                boolean black=true;
                for(int j=0;j<16*9;j++){
                    boules[i].surface[j].colo=boules[i].surface[j].colo.darker();
                    if(!boules[i].surface[j].colo.equals(Color.black))black=false;
                }
                if(black){
                    boules[i]=null;
                }
            }
        }

        for(int i=0;i<1000;i++){
            if(kug[i]!=null){
                kug[i].x=kug[i].x+kugdir[i].x;
                kug[i].y=kug[i].y+kugdir[i].y;
                kug[i].z=kug[i].z+kugdir[i].z;
            }
        }
        for(int i=0;i<1000;i++){
            if(kug[i]!=null){
                if(kug[i].entf()>oob)kug[i]=null;
            }
            if(boules[i]!=null){
                if(boules[i].kern.entf()>oob)boules[i]=null;
            }
        }
        for(int i=0;i<1000;i++){
            if(boules[i]!=null){
                for(int j=0;j<16*9;j++){
                    if(boules[i].surface[j].entf()<boules[i].surface[j].radi())halted=true;
                }
            }
        }
        boulestranslate(-2,0,0);
        if(halted)h.drawString("Game over! Planets: "+(cits),100,100);
        h.setColor(Color.white);
        for(int i=0;i<countero;i++){
            if(v[i].z>0){
                double alpha=Math.atan(v[i].x/v[i].z);
                double beta=Math.atan(v[i].y/v[i].z);
                int qx=(int)(alpha/winkel*200.0);
                int qy=(int)(beta/winkel*200.0);
                if(Math.abs(qx)<200&&Math.abs(qy)<200){
                    int size=(5-v[i].m);
                    if(v[i].m<=grenze){
                        h.fillOval(200+qx-(size/2),240+qy-(size/2),size,size);
                    }
                }
            }
        }
//        for(int i=0;i<100;i++){
//            h.fillOval(zd[i].x,zd[i].y,2,2);
//        }
        int pos=0;
        int posk=0;
        int[]index=new int[1000];
        int[]indexk=new int[1000];
        for(int i=0;i<1000;i++){
            boolean iplus=false;
            if(boules[i]!=null){
                index[pos]=i;
                pos++;
                posk=0;
                for(int j=0;j<1000;j++){
                    if(kug[j]!=null){
                        indexk[posk]=j;
                        posk++;
                        for(int k=0;k<(16*9);k++){

            Vector ve=boules[i].surface[k].getMid();
            Vector kv=kug[j];
            if(Math.sqrt((ve.x-kv.x)*(ve.x-kv.x)+(ve.y-kv.y)*(ve.y-kv.y)+(ve.z-kv.z)*(ve.z-kv.z))<boules[i].surface[k].radi()){
                kug[j]=null;
                boules[i].fading=true;
                iplus=true;
                posk--;
                cits++;
            }
            if(iplus)break;

                        }
                        if(iplus)break;
                    }
                    if(iplus)break;
                }
                if(iplus)break;
            }
            iplus=false;
        }
        
        int itemcount=pos*16*9+posk;
        Sortelem[] s1=new Sortelem[itemcount];
        Sortelem[] s2=new Sortelem[itemcount];
        int ps=0;
        for(int i=0;i<pos;i++){
            for(int j=0;j<16*9;j++){
                s1[ps]=new Sortelem(0);
                s1[ps].t=boules[index[i]].surface[j];
                s1[ps].entf=s1[ps].t.entf();
                ps++;
            }
        }
        for(int i=0;i<posk;i++){
            s1[ps]=new Sortelem(1);
            s1[ps].v=kug[indexk[i]];
            s1[ps].entf=s1[ps].v.entf();
            ps++;
        }
        ps=0;
        boolean[]weg=new boolean[itemcount];
        for(int i=0;i<itemcount;i++){
            double e=0;
            int indexe=0;
            for(int j=0;j<itemcount;j++){
                if(!weg[j]&&s1[j].entf>e){
                    indexe=j;
                    e=s1[j].entf;
                }
            }
            s2[ps]=s1[indexe];
            weg[indexe]=true;
            ps++;
        }
        double view=Math.PI/2;
        for(int i=0;i<itemcount;i++){
            if(s2[i].type==0){
                h.setColor(Color.black);
                Quartle t=s2[i].t;
                Vector a=t.a;
                Vector b=t.b;
                Vector c=t.c;
                Vector d=t.d;
                if(a.x>0&&b.x>0&&c.x>0&&d.x>0){
                    int qx=(int)(Math.atan((a.y/a.x))/(view/2)*200);
                    int qy=(int)(Math.atan((a.z/a.x))/(view/2)*200);
                    int qx2=(int)(Math.atan((b.y/b.x))/(view/2)*200);
                    int qy2=(int)(Math.atan((b.z/b.x))/(view/2)*200);
                    int qx3=(int)(Math.atan((c.y/c.x))/(view/2)*200);
                    int qy3=(int)(Math.atan((c.z/c.x))/(view/2)*200);
                    int qx4=(int)(Math.atan((d.y/d.x))/(view/2)*200);
                    int qy4=(int)(Math.atan((d.z/d.x))/(view/2)*200);

                    java.awt.Polygon poli=new java.awt.Polygon();
                    poli.addPoint(200+qx,240+qy);
                    poli.addPoint(200+qx2,240+qy2);
                    poli.addPoint(200+qx3,240+qy3);
                    poli.addPoint(200+qx4,240+qy4);
                    h.setColor(s2[i].t.colo);
                    h.fillPolygon(poli);
                    h.setColor(Color.black);
                    h.drawPolygon(poli);

                }
            }
            else{
                h.setColor(Color.gray);
                Vector v=s2[i].v;
                if(v.x>0){
                    int qx=(int)(Math.atan((v.y/v.x))/(view/2)*200);
                    int qy=(int)(Math.atan((v.z/v.x))/(view/2)*200);
                    double ent=v.entf();
                    int radius=(int)(Math.atan(5/ent)/(view/2)*200);
                    h.fillOval(200+qx-radius,240+qy-radius,2*radius,2*radius);
                }
            }
        }
        g.drawImage(img,0,0,this);
        paint(g);
    }
}
class Circle{
    Vector[] vs;
    public Circle(){
        vs=new Vector[16];
    }
}
class Circles{
    Circle[] c;
    public Circles(){
        c=new Circle[9];
    }
}
class Ball{
    int a;
    int b;
    int c;
    int type;
    Quartle[] surface=new Quartle[16*9];
    Vector kern=new Vector(0,0,0);
    boolean fading=false;
    Vector flugdir;
    double linksrot;
    double untenrot;
    public Ball(int a,int b,int c,int type){
        this.a=a;
        this.b=b;
        this.c=c;
        this.type=type;
        double zwin=-Math.PI/2-Math.PI/8;
        flugdir=new Vector(0,0,0);
        Circles cir=new Circles();
        int fak=(int)(Math.random()*2);
        boolean sper=false;
        for(int i=0;i<9;i++){
            cir.c[i]=new Circle();
            zwin+=Math.PI/8;
            if((i==0||i==8)&&fak==1)sper=true;
            if(sper)fak=0;
            if(sper&&i>0&&i<8){
                sper=false;
                fak=1;
            }
            double z=a*Math.sin(zwin)+fak*Math.random()*10;
            double x=b*Math.cos(zwin);
            double y=c*Math.cos(zwin);
            double betawin=0;
            for(int j=0;j<16;j++){
                betawin+=Math.PI/8;
                double x2=Math.sin(betawin)*x+fak*Math.random()*10;
                double y2=Math.cos(betawin)*y+fak*Math.random()*10;
                cir.c[i].vs[j]=new Vector(x2,y2,z);
            }
        }
        int pos=0;
        Circle cl=cir.c[0];
        for(int i=0;i<16;i++){
            Vector q1=new Vector(0,0,0);
            Vector q2=new Vector(0,0,0);
            Vector q3=new Vector(0,0,0);
            Vector q4=new Vector(0,0,0);
            if(i==0){
                q1=cl.vs[15].copyVec();
                q2=cl.vs[0].copyVec();
                q3=new Vector(0,0,-a);
                q4=new Vector(0,0,-a);
            }
            else{
                q1=cl.vs[i-1].copyVec();
                q2=cl.vs[i].copyVec();
                q3=new Vector(0,0,-a);
                q4=new Vector(0,0,-a);
            }
            Color co=Color.gray;
            for(int k=0;k<5;k++){
                if(0==((int)(Math.random()*2)))co=co.brighter();
                else co=co.darker();
            }
            surface[pos]=new Quartle(q1,q2,q3,q4,co);
            pos++;
        }
        for(int i=0;i<8;i++){
            Circle circ1=cir.c[i];
            Circle circ2=cir.c[i+1];
            for(int j=0;j<16;j++){
                Vector q1=circ1.vs[j].copyVec();
                Vector q2=circ1.vs[(j+1)%16].copyVec();
                Vector q3=circ2.vs[(j+1)%16].copyVec();
                Vector q4=circ2.vs[j].copyVec();
                Color co=Color.gray;
                for(int k=0;k<5;k++){
                    if(0==((int)(Math.random()*2)))co=co.brighter();
                    else co=co.darker();
                }
                surface[pos]=new Quartle(q1,q2,q3,q4,co);
                pos++;
            }
        }
    }

    public void rotRight(double wink){
        if(kern.x!=0&&kern.y!=0&&kern.z!=0){
            kern.rotRight(wink);
        }
        for(int i=0;i<(9*16);i++){
            surface[i].rotRight(wink);
        }
    }
    public void rotDown(double wink){
        if(kern.x!=0&&kern.y!=0&&kern.z!=0){
            kern.rotDown(wink);
        }
        for(int i=0;i<(9*16);i++){
            surface[i].rotDown(wink);
        }
    }
    public void translate(double x,double y,double z){
        kern.translate(x,y,z);
        for(int i=0;i<(9*16);i++){
            surface[i].translate(x,y,z);
        }
    }
    public void leftturn(double wink){
        double ax=kern.x+0.5;
        double ay=kern.y+0.5;
        double az=kern.z+0.5;
        translate(-kern.x-0.5,-kern.y-0.5,-kern.z-0.5);
        for(int i=0;i<(16*9);i++){
            Vector a=surface[i].a;
            Vector b=surface[i].b;
            Vector c=surface[i].c;
            Vector d=surface[i].d;
            double x=a.x;
            double y=a.y;
            double win=Math.atan(y/x);
            if(x<0)win+=Math.PI;
            win+=wink;
            double len=Math.sqrt(x*x+y*y);
            a.x=(Math.cos(win))*len;
            a.y=(Math.sin(win))*len;
            x=b.x;
            y=b.y;
            win=Math.atan(y/x);
            if(x<0)win+=Math.PI;
            win+=wink;
            len=Math.sqrt(x*x+y*y);
            b.x=(Math.cos(win))*len;
            b.y=(Math.sin(win))*len;
            x=c.x;
            y=c.y;
            win=Math.atan(y/x);
            if(x<0)win+=Math.PI;
            win+=wink;
            len=Math.sqrt(x*x+y*y);
            c.x=(Math.cos(win))*len;
            c.y=(Math.sin(win))*len;
            x=d.x;
            y=d.y;
            win=Math.atan(y/x);
            if(x<0)win+=Math.PI;
            win+=wink;
            len=Math.sqrt(x*x+y*y);
            d.x=(Math.cos(win))*len;
            d.y=(Math.sin(win))*len;
        }
        translate(ax,ay,az);
    }
    public void downturn(double wink){
        double ax=kern.x+0.5;
        double ay=kern.y+0.5;
        double az=kern.z+0.5;
        translate(-kern.x-0.5,-kern.y-0.5,-kern.z-0.5);
        for(int i=0;i<16*9;i++){
            Vector a=surface[i].a;
            Vector b=surface[i].b;
            Vector c=surface[i].c;
            Vector d=surface[i].d;
            double x=a.x;
            double y=a.z;
            double win=Math.atan(y/x);
            if(x<0)win+=Math.PI;
            win+=wink;
            double len=Math.sqrt(x*x+y*y);
            a.x=(Math.cos(win))*len;
            a.z=(Math.sin(win))*len;
            x=b.x;
            y=b.z;
            win=Math.atan(y/x);
            if(x<0)win+=Math.PI;
            win+=wink;
            len=Math.sqrt(x*x+y*y);
            b.x=(Math.cos(win))*len;
            b.z=(Math.sin(win))*len;
            x=c.x;
            y=c.z;
            win=Math.atan(y/x);
            if(x<0)win+=Math.PI;
            win+=wink;
            len=Math.sqrt(x*x+y*y);
            c.x=(Math.cos(win))*len;
            c.z=(Math.sin(win))*len;
            x=d.x;
            y=d.z;
            win=Math.atan(y/x);
            if(x<0)win+=Math.PI;
            win+=wink;
            len=Math.sqrt(x*x+y*y);
            d.x=(Math.cos(win))*len;
            d.z=(Math.sin(win))*len;
        }
        translate(ax,ay,az);
    }
}
class Quartle{
    Vector a;
    Vector b;
    Vector c;
    Vector d;
    Color colo;
    public Quartle(Vector a,Vector b,Vector c,Vector d,Color colo){
        this.a=a;
        this.b=b;
        this.c=c;
        this.d=d;
        this.colo=colo;
    }
    public void translate(double x,double y,double z){
        a.translate(x,y,z);
        b.translate(x,y,z);
        c.translate(x,y,z);
        d.translate(x,y,z);
    }
    public void rotRight(double wink){
        a.rotRight(wink);
        b.rotRight(wink);
        c.rotRight(wink);
        d.rotRight(wink);
    }
    public void rotDown(double wink){
        a.rotDown(wink);
        b.rotDown(wink);
        c.rotDown(wink);
        d.rotDown(wink);
    }
    public double entf(){
        return (a.entf()+b.entf()+c.entf()+d.entf())/4;
    }
    public double radi(){
        return Math.sqrt((a.x-c.x)*(a.x-c.x)+(a.y-c.y)*(a.y-c.y)+(a.z-c.z)*(a.z-c.z));
    }
    public Vector getMid(){
        double v1=(a.x+b.x+c.x+d.x)/4;
        double v2=(a.y+b.y+c.y+d.y)/4;
        double v3=(a.z+b.z+c.z+d.z)/4;
        return new Vector(v1,v2,v3);
    }
}
class Vector{
    double x;
    double y;
    double z;
    public Vector(double x,double y,double z){
        this.x=x;
        this.y=y;
        this.z=z;
    }
    public void translate(double a,double b,double c){
        x+=a;
        y+=b;
        z+=c;
    }
    public Vector copyVec(){
        return new Vector(x,y,z);
    }
    public void rotRight(double wink){
        if(x==0&&y==0)return;
        double win=Math.atan(y/x);
        if(x<0)win+=Math.PI;
        win+=wink;
        double len=Math.sqrt(x*x+y*y);
        x=(Math.cos(win))*len;
        y=(Math.sin(win))*len;
    }
    public void rotDown(double wink){
        if(x==0&&z==0)return;
        double win=Math.atan(z/x);
        if(x<0)win+=Math.PI;
        win+=wink;
        double len=Math.sqrt(x*x+z*z);
        x=(Math.cos(win))*len;
        z=(Math.sin(win))*len;
    }
    public double entf(){
        return Math.sqrt(x*x+y*y+z*z);
    }
}
class Sortelem{
    int type=0;
    Quartle t;
    Vector v;
    double entf;
    Color col;
    public Sortelem(int type){
        this.type=type;
    }
}
class PDialog extends Dialog{
    Label a;
    Button but;
    Label l;
    TextArea ta;
    SpaceBomber pt;
    public PDialog(SpaceBomber pt){
        super((Frame)pt);
        setTitle("SpaceBomber");
        this.pt=pt;
        resize(300,300);
        l=new Label("");
        but=new Button("Start");
        ta=new TextArea("Space Bomber 3D\n");
        ta.appendText("(c) Astro Solutions 2003\n");
        ta.appendText("You fly through space and have to\n");
        ta.appendText("bomb asteroids. \n");
        ta.appendText("Move your spacecraft with the cursor keys.  \n");
        ta.appendText("Press DELETE to shoot, ENTER to restart. \n");
        ta.appendText("http://www.astrosolutions.de");
        add(ta);
        add(but);
        add(l);
        ta.reshape(10,30,280,200);
        but.reshape(10,240,100,27);
    }
    public boolean handleEvent(Event evt){
        if(evt.id==Event.ACTION_EVENT){
            hide();
            pt.sc.start();
        }
        if(evt.id==Event.WINDOW_DESTROY){
            hide();
            pt.sc.start();
        }
        return false;
    }
}
class Veks{
    double x,y,z;
    int m;
    public Veks(double a,double b,double c,int d){
        x=a;
        y=b;
        z=c;
        m=d;
    }
}
