import java.io.*;
import java.awt.*;
import java.net.*;
import java.applet.*;
public class AstroJump extends Applet implements Runnable{
    Thread t;
    List l;
    Button start;
    Button start2;
    Panel p;
    boolean startb=false;
    boolean start2b=false;
    KeyboardMapperApplet km=null;
    MediaTracker tracker;
    XScreenAstroJump p2;
    static AstroJump app;
    private static final long serialVersionUID = -5703341621113405534L;
    public void init(){
//        super("Astro Solutions AstroJump");
//        pack();
        resize(640,680);
        setLayout(null);
        app=this;
        p=new Panel();
        p.setLayout(null);
        l=new List();
        start=new Button("two players");
        start2=new Button("one player");
        p.add(l);
        p.add(start);
        p.add(start2);
        p.reshape(0,0,640,680);
        add(p);
        p.show();
        l.reshape(10,40,380,280);
        start.reshape(10,330,380,27);
        start2.reshape(10,360,380,27);
        show();
        load();
        t=new Thread(this);
        t.start();
    }
    public static InputStream getInputStream(String filename){
        try{
            InputStream is=app.getClass().getResourceAsStream("/"+filename);
            return is;
        }
        catch(Exception e){
            e.printStackTrace(System.out);
        }
        return null;
    }
    public static Image getImage(String filename){
        try{
            URL url=app.getClass().getResource("/"+filename);
            Image img=app.getToolkit().getImage(url);
            return img;
        }
        catch(Exception e){
        }
        return null;
    }
    public void load(){
        try{
            InputStream fis=AstroJump.getInputStream("levs.ini");
            DataInputStream dis=new DataInputStream(fis);
            String inp="";
            while((inp=dis.readLine())!=null){
                l.addItem(inp);
            }
            fis.close();
        }
        catch(Exception e){
        }
    }
    public void run(){
        p.hide();
        km=new KeyboardMapperApplet(this);
        add(km);
        km.reshape(0,40,400,400);
        km.show();
        while(!km.closed){
            try{
                Thread.sleep(100);
            }
            catch(Exception e){
            }
        }
        p.show();
        while(true){
            try{
                Thread.sleep(100);
                if(startb){
                    startb=false;
                    int ind=l.getSelectedIndex();
                    if(ind!=-1){
                         new Loadera(l.getItem(ind),false);
                    }
                }
                if(start2b){
                    start2b=false;
                    int ind=l.getSelectedIndex();
                    if(ind!=-1){
                         new Loadera(l.getItem(ind),true);
                    }
                }
            }
            catch(Exception e){
            }
        }
    }
    public static void main(String[]args){
        new AstroJump();
    }
    public boolean handleEvent(Event evt){
        if(evt.id==Event.WINDOW_DESTROY){
            System.exit(0);
        }
        if(evt.id==Event.ACTION_EVENT){
            if(evt.target==start){
                startb=true;
            }
            if(evt.target==start2){
                start2b=true;
            }
        }
        return false;
    }
}
class Loadera implements Runnable{
    String level;
    Thread t;
    int xl;
    int yl;
    int[][]backgr;
    String[][]objs;
    StringHolder sh;
    StringHolder sh2;
    StringPair sp;
    StringPair sp2;
    int figures;
    int objects;
    JumpObject[]jumpo;
    FigureObject[]figo;
    FigureObject player1;
    FigureObject player2;
    Kugel[]kugel=new Kugel[200];
    Image back;
    Image stone;
    boolean one=false;
    public Loadera(String level,boolean one){
        this.level=level;
        this.one=one;
        AstroJump.app.tracker=new MediaTracker(AstroJump.app);
        sh=new StringHolder();
        sh2=new StringHolder();
        sp=new StringPair();
        sp2=new StringPair();
        player1=new FigureObject("player1.fig");
        player2=new FigureObject("player2.fig");
        try{
            back=AstroJump.getImage("backaj.gif");
            stone=AstroJump.getImage("stoneaj.gif");
            AstroJump.app.tracker.addImage(back,0);
            AstroJump.app.tracker.addImage(stone,0);
        }
        catch(Exception e){
        }
        t=new Thread(this);
        t.start();
    }
    public void createKugel(boolean yours,double x,double y,double xdrift,double ydrift){
        int c=0;
        while(c<200&&kugel[c]!=null&&!kugel[c].off){
            c++;
        }
        if(c==200){
            c=(int)(Math.random()*200);
        }
        kugel[c]=new Kugel(yours,x,y,xdrift,ydrift);
    }
    public void run(){
        try{
            InputStream fis=AstroJump.getInputStream(level);
            DataInputStream dis=new DataInputStream(fis);
            String s=dis.readLine();
            xl=new Integer(dis.readLine()).intValue();
            yl=new Integer(dis.readLine()).intValue();
            backgr=new int[xl][yl];
            objs=new String[xl][yl];
            for(int i=0;i<xl;i++){
                for(int j=0;j<yl;j++){
                    s=dis.readLine();
                    if("s".equals(s)){
                        backgr[i][j]=1;
                    }
                    else if("start1".equals(s)){
                        backgr[i][j]=2;
                        player1.x=i*40;
                        player1.y=j*40+40;
                        player1.xs=i*40;
                        player1.ys=j*40+40;
                    }
                    else if("start2".equals(s)){
                        backgr[i][j]=3;
                        player2.x=i*40;
                        player2.y=j*40+40;
                        player2.xs=i*40;
                        player2.ys=j*40+40;
                    }
                    else if("f".equals(s)){
                        objs[i][j]=dis.readLine();
                        backgr[i][j]=4;
                        sh.add(objs[i][j]);
                        figures++;
                    }
                    else if("o".equals(s)){
                        objs[i][j]=dis.readLine();
                        backgr[i][j]=5;
                        sh2.add(objs[i][j]);
                        objects++;
                    }
                }
            }
            fis.close();
            for(int i=0;i<sh.s.length;i++){
                FigureObject fi=new FigureObject(sh.s[i]);
                sp.add(sh.s[i],fi);
            }
            for(int i=0;i<sh2.s.length;i++){
                JumpObject fi=new JumpObject(sh2.s[i]);
                sp2.add(sh2.s[i],fi);
            }
            figo=new FigureObject[figures];
            int c=0;
            for(int i=0;i<xl;i++){
                for(int j=0;j<yl;j++){
                    if(backgr[i][j]==4){
                        FigureObject fio=(FigureObject)sp.getObj(objs[i][j]);
                        figo[c]=fio.cloneo();
                        figo[c].x=i*40;
                        figo[c].y=j*40+40;
                        figo[c].xdrift=figo[c].speed;
                        c++;
                    }
                }
            }
            jumpo=new JumpObject[objects];
            c=0;
            for(int i=0;i<xl;i++){
                for(int j=0;j<yl;j++){
                    if(backgr[i][j]==5){
                        JumpObject fio=(JumpObject)sp2.getObj(objs[i][j]);
                        jumpo[c]=fio.cloneo();
                        jumpo[c].x=i*40;
                        jumpo[c].y=j*40;
                        c++;
                    }
                }
            }
            new XScreenAstroJump(this,one);
        }
        catch(Exception e){
            System.out.println("level load error: "+e);
        }
    }
}
class XScreenAstroJump extends Panel implements Runnable{
    Thread t;
    CanvAstroJump canv1;
    CanvAstroJump canv2;
    Loadera loa;
    boolean running=true;
    int left2=121;
    int right2=99;
    int up2=115;
    int down2=120;
    int ok=0;
    int enter2=97;
    boolean wonf=false;
    int points1=0;
    int points2=0;
    boolean one=false;
    private static final long serialVersionUID = 5533344852083632505L;
    public XScreenAstroJump(Loadera loa,boolean one){
//        super("Astro Solutions AstroJump");
        this.one=one;
//        pack();
        if(!one){
            resize(640,680);
        }
        else{
            setSize(640,360);
        }
        setLayout(null);
        this.loa=loa;
        canv1=new CanvAstroJump(loa,false);
        canv2=new CanvAstroJump(loa,true);
        AstroJump.app.p.hide();
        AstroJump.app.p2=this;
        AstroJump.app.add(AstroJump.app.p2);
        AstroJump.app.p2.reshape(0,0,640,680);
        add(canv1);
        if(!one){
            add(canv2);
        }
        canv1.reshape(0,40,640,320);
        if(!one){
            canv2.reshape(0,360,640,320);
        }
        requestFocus();
        show();
        t=new Thread(this);
        t.start();
    }
    public void run(){
        while(running){
            try{
                Thread.sleep(50);
                if(loa.player1.lifes==0){
                    canv1.info="player 1 has lost";
                }
                if(loa.player2.lifes==0){
                    canv2.info="player 2 has lost";
                }
                boolean won=true;
                for(int i=0;i<loa.figo.length;i++){
                    if(!loa.figo[i].dead){
                        won=false;
                    }
                }
                if(won){
                    if(!wonf){
                        wonf=true;
                        points1=(int)loa.player1.points;
                        points2=(int)loa.player2.points;
                    }
                    canv1.info="you have won! points: "+points1;
                    canv2.info="you have won! points: "+points2;
                }
                canv1.repaint();
                canv2.repaint();
            }
            catch(Exception e){
            }
        }
    }
    public boolean handleEvent(Event evt){
        if(evt.id==Event.WINDOW_DESTROY){
            AstroJump.app.remove(AstroJump.app.p2);
            hide();
            AstroJump.app.p.show();
            running=false;
        }
        if(evt.id==Event.KEY_PRESS||evt.id==Event.KEY_ACTION){
            int evtkey=evt.key;
            if(AstroJump.app.km!=null&&AstroJump.app.km.applyb){
                evtkey=AstroJump.app.km.getKeyCode(evtkey);
            }
            if(evtkey==27||evtkey==Event.ESCAPE){
                AstroJump.app.remove(AstroJump.app.p2);
                hide();
                AstroJump.app.p.show();
                running=false;
            }
            canv1.process(this,evtkey);
        }
        return false;
    }
    public void process2(int key){
        canv2.process2(this,key);
    }
    public void process(int key){
//System.out.println("key: "+key);
            if(key==Event.LEFT&&loa.player1.xdrift>-12){
                loa.player1.xdrift--;
            }
            if(key==Event.RIGHT&&loa.player1.xdrift<12){
                loa.player1.xdrift++;
            }
            if(key==Event.UP){
                if(loa.player1.canjump){
                    loa.player1.startjump();
                }
                else{
                    loa.player1.ydrift-=0.15;
                }
            }
            if(key==Event.DOWN){
                loa.player1.ydrift+=0.15;
            }
            if(key==Event.ENTER||key==10||key==13){
                loa.createKugel(true,loa.player1.x+20,loa.player1.y-20,loa.player1.xdrift*(loa.player1.gunadd+1)/0.5,0);
            }
            if(key==left2&&loa.player2.xdrift>-12){
                loa.player2.xdrift--;
            }
            if(key==right2&&loa.player2.xdrift<12){
                loa.player2.xdrift++;
            }
            if(key==up2){
                if(loa.player2.canjump){
                    loa.player2.startjump();
                }
                else{
                    loa.player2.ydrift-=0.15;
                }
            }
            if(key==down2){
                loa.player2.ydrift+=0.15;
            }
            if(key==enter2){
                loa.createKugel(true,loa.player2.x+20,loa.player2.y-20,loa.player2.xdrift*(loa.player2.gunadd+1)/0.5,0);
            }
    }
}
class ImFrameAstroJump extends Frame{
    Image img;
    private static final long serialVersionUID = 1006632597828323101L;
    public ImFrameAstroJump(int xl,int yl){
        pack();
        img=createImage(xl*40+200,yl*40+200);
    }
}

class CanvAstroJump extends Canvas{
    Loadera loa;
    boolean two;
    Image img;
    int width=640;
    int height=320;
    Graphics h;
    FigureObject player1;
    FigureObject player2;
    String info="";
    private static final long serialVersionUID = 1498654098475645894L;
    public CanvAstroJump(Loadera loa,boolean two){
        this.two=two;
        this.loa=loa;
        player1=loa.player1;
        player2=loa.player2;
        ImFrameAstroJump imf=new ImFrameAstroJump(loa.xl,loa.yl);
        img=imf.img;
        h=img.getGraphics();
    }
    public synchronized void process(XScreenAstroJump xsaja,int key){
        xsaja.process2(key);
    }
    public synchronized void process2(XScreenAstroJump xsaja,int key){
        xsaja.process(key);
    }
    public void paint(Graphics g){
    }
    public synchronized void update(Graphics g){
        h.setColor(Color.white);
        h.fillRect(0,0,200+loa.xl*40,200+loa.yl*40);
        int xpos=(int)loa.player1.x;
        int ypos=(int)loa.player1.y-40;
        if(two){
            xpos=(int)loa.player2.x;
            ypos=(int)loa.player2.y-40;
        }
        int xl=loa.xl;
        int yl=loa.yl;
        int[][]backgr=loa.backgr;
        int xposc=(xpos-width/2-40)/40;
        int yposc=(ypos-height/2-40)/40;
        int wxc=(width+80)/40;
        int wyc=(height+80)/40;
        for(int i=xposc;i<xposc+wxc;i++){
            for(int j=yposc;j<yposc+wyc;j++){
                if(i>=0&&i<xl&&j>=0&&j<yl){
                    if(backgr[i][j]!=1){
                        h.drawImage(loa.back,100+i*40,100+j*40,this);
                    }
                    else if(backgr[i][j]==1){
                        h.drawImage(loa.stone,100+i*40,100+j*40,this);
                    }
                }
            }
        }
        JumpObject[]jo=loa.jumpo;
        for(int i=0;i<jo.length;i++){
            if(two){
                if(loa.player2.x+20>=jo[i].x&&loa.player2.x+20<jo[i].x+40){
                    if(!jo[i].off&&loa.player2.y-20>=jo[i].y&&loa.player2.y-20<jo[i].y+40){
                        loa.player2.lifes+=jo[i].lifes;
                        loa.player2.points+=jo[i].points;
                        jo[i].pos=1;
                        loa.player2.faster+=jo[i].faster;
                        loa.player2.gunadd+=jo[i].gunadd;
                        jo[i].off=true;
                    }
                }
            }
            else{
                if(loa.player1.x+20>=jo[i].x&&loa.player1.x+20<jo[i].x+40){
                    if(!jo[i].off&&loa.player1.y-20>=jo[i].y&&loa.player1.y-20<jo[i].y+40){
                        loa.player1.lifes+=jo[i].lifes;
                        loa.player1.points+=jo[i].points;
                        jo[i].pos=1;
                        loa.player1.faster+=jo[i].faster;
                        loa.player1.gunadd+=jo[i].gunadd;
                        jo[i].off=true;
                    }
                }
            }
            if(jo[i].pos==0){
                h.drawImage(jo[i].pic,100+jo[i].x,100+jo[i].y,this);
            }
            else if(jo[i].pos<=20){
                h.setColor(Color.blue);
                h.drawString(""+jo[i].points,100+jo[i].x+jo[i].pos*4,100+jo[i].y-jo[i].pos*8);
                jo[i].pos++;
            }
        }
        Kugel[]kugel=loa.kugel;
        FigureObject[]fo=loa.figo;
        for(int i=0;i<fo.length;i++){
            if(!fo[i].dead){
                Image ima=fo[i].move(loa,two);
                h.drawImage(ima,100+(int)fo[i].x,100+(int)fo[i].y-40,this);
                int ma=(int)(Math.random()*100);
                int mb=(int)(Math.random()*100);
                int mc=(int)(Math.random()*10);
                int md=(int)(Math.random()*10);
                if(mc==0&&ma<fo[i].sprung){
                    fo[i].startjump();
                }
                if(md==0&&mb<fo[i].baller){
                    loa.createKugel(false,fo[i].x+20,fo[i].y-20,fo[i].xdrift*2,0);
                }
                if(two){
                    if(loa.player2.x+20>=fo[i].x&&loa.player2.x+20<fo[i].x+40){
                        if(loa.player2.y-20>=fo[i].y-40&&loa.player2.y-20<fo[i].y){
                            player2.loose();
                        }
                    }
                }
                else{
                    if(loa.player1.x+20>=fo[i].x&&loa.player1.x+20<fo[i].x+40){
                        if(loa.player1.y-20>=fo[i].y-40&&loa.player1.y-20<fo[i].y){
                            player1.loose();
                        }
                    }
                }
                for(int j=0;j<200;j++){
                    if(kugel[j]!=null&&!kugel[j].off&&kugel[j].yours){
                        if(kugel[j].x>=fo[i].x&&kugel[j].x<fo[i].x+40&&kugel[j].y<fo[i].y&&kugel[j].y>=fo[i].y-40){
                            fo[i].dead=true;
                        }
                    }
                }
            }
        }
        for(int i=0;i<200;i++){
            if(kugel[i]!=null&&!kugel[i].off){
                kugel[i].move(two);
                kugel[i].stone(loa);
                h.setColor(Color.blue);
                h.fillOval(100+(int)kugel[i].x-3,100+(int)kugel[i].y-3,6,6);
                if(!kugel[i].yours&&two){
                    if(kugel[i].x>=loa.player2.x&&kugel[i].x<loa.player2.x+40&&kugel[i].y<loa.player2.y&&kugel[i].y>=loa.player2.y-40){
                        player2.loose();
                        kugel[i].off=true;
                    }
                }
                if(!kugel[i].yours&&!two){
                    if(kugel[i].x>=loa.player1.x&&kugel[i].x<loa.player1.x+40&&kugel[i].y<loa.player1.y&&kugel[i].y>=loa.player1.y-40){
                        player1.loose();
                        kugel[i].off=true;
                    }
                }
            }
        }
        Image pim1=loa.player1.move(loa,two);
        Image pim2=loa.player2.move(loa,two);
        h.drawImage(pim1,100+(int)loa.player1.x,100+(int)loa.player1.y-40,this);
        h.drawImage(pim2,100+(int)loa.player2.x,100+(int)loa.player2.y-40,this);
        h.setColor(Color.red);
        h.drawString(info,100+xpos-width/3,100+ypos-height/3);
        g.setColor(Color.white);
        g.fillRect(0,0,800,600);
        g.drawImage(img,-100-xpos+width/2,-100-ypos+height/2,this);
        paint(g);
    }
}
class Kugel{
    double x;
    double y;
    double xdrift;
    double ydrift;
    int cur;
    boolean yours=false;
    boolean off=false;
    public Kugel(boolean yours,double x,double y,double xdrift,double ydrift){
        this.yours=yours;
        this.x=x;
        this.y=y;
        this.xdrift=xdrift;
        this.ydrift=ydrift;
        cur=0;
    }
    public void stone(Loadera loa){
        int xl=loa.xl;
        int yl=loa.yl;
        int[][]backgr=loa.backgr;
        int xj=(int)x/40;
        int yj=(int)y/40;
        if(xj>=0&&x>=0&&yj>=0&&y>=0&&xj<xl&&yj<yl){
            if(backgr[xj][yj]==1){
                off=true;
            }
        }
        if(x<0||y<0||xj>=xl||yj>=yl){
            off=true;
        }
    }
    public void move(boolean two){
        if(two){
            return;
        }
        if(off){
            return;
        }
        x=x+xdrift;
        y=y+ydrift;
        cur++;
        if(cur==40){
            off=true;
        }
    }
}
class JumpObject{
    String source;
    Image pic;
    double points;
    int lifes;
    double faster;
    double gunadd;
    int x;
    int y;
    int pos=0;
    boolean off=false;
    public JumpObject(String source){
        this.source=source;
        load();
    }
    public JumpObject(){
    }
    public void load(){
        try{
            InputStream fis=AstroJump.getInputStream(source);
            DataInputStream dis=new DataInputStream(fis);
            String a=dis.readLine();
            String imn=dis.readLine();
            points=new Double(dis.readLine()).doubleValue();
            lifes=new Integer(dis.readLine()).intValue();
            faster=new Double(dis.readLine()).doubleValue();
            gunadd=new Double(dis.readLine()).doubleValue();
            fis.close();
            pic=AstroJump.getImage(imn);
            AstroJump.app.tracker.addImage(pic,0);
        }
        catch(Exception e){
            System.out.println("object load error: "+e);
        }
    }
    public JumpObject cloneo(){
        JumpObject ret=new JumpObject();
        ret.pic=pic;
        ret.points=points;
        ret.lifes=lifes;
        ret.faster=faster;
        ret.gunadd=gunadd;
        return ret;
    }
}
class FigureObject{
    double speed;
    double sprung;
    double baller;
    Image[]running;
    Image[]jumpup;
    Image[]jumpdown;
    String source;
    double xs;
    double ys;
    double x;
    double y;
    int cur;
    int curup;
    int curdown;
    double t=0;
    double jstartx;
    double jstarty;
    double xdrift;
    double ydrift;
    double lx;
    double ly;
    double lastdriftx=0;
    double lastdrifty=0;
    boolean canjump=false;
    boolean jumpb=false;
    boolean jumpupb=false;
    boolean jumpdownb=false;
    boolean dead=false;
    boolean player;
    int lifes=3;
    double points=0;
    double faster=0;
    double gunadd=0;
    int oldindex=0;
    int oldart=0;
    int curindex=0;
    int curart=0;
    public FigureObject(String source){
        this.source=source;
        load();
    }
    public FigureObject(){
    }
    public void loose(){
        lifes--;
        x=xs;
        y=ys;
        xdrift=0;
        ydrift=0;
        jumpb=false;
    }
    public void startjump(){
        if(canjump){
            cur=0;
            curup=0;
            curdown=0;
            y=y-1;
            jstartx=x;
            jstarty=y;
            lx=jstartx;
            ly=jstarty;
            ydrift=-20;
            t=0;
            jumpb=true;
            jumpupb=true;
        }
    }
    public Image move(Loadera loa,boolean two){
        double xo=x;
        Image ret=null;
        int[][]backgr=loa.backgr;
        int xl=loa.xl;
        int yl=loa.yl;
        if(x<0){
            x=xl*40+x;
        }
        if(x>xl*40){
            x=x-xl*40;
        }
        if(lx<0){
            lx=xl*40+lx;
        }
        if(lx>xl*40){
            lx=lx-xl*40;
        }
//+20 added on 27.03.2023
        int xj=(int)(x+20)/40;
        int yj=(int)y/40;
        if(yj>=yl){
//            dead=true;
            y=0;
            ly=0;
        }
        else{
            if(xj>=0&&x>=0&&xj<xl&&yj>=0){
                int val=backgr[xj][yj];
                if(val==1){
                    jumpb=false;
                    jumpupb=false;
                    jumpdownb=false;
                    canjump=true;
                    curup=0;
                    curdown=0;
                    ydrift=0;
                    y=yj*40;
                }
                else if((val==0||val==2||val==3)&&!jumpb){
                    ret=jumpdown[jumpdown.length-1];
                    curindex=jumpdown.length-1;
                    curart=2;
                    ydrift=ydrift+0.25;
                    canjump=false;
                }
                else{
                    canjump=false;
                }
            }
            else{
                canjump=false;
            }
        }
        if(!jumpb){
            if(!two){
                x=x+xdrift*(faster+1)*0.25;
                y=y+ydrift*(faster+1)*0.25;
            }
            if(xdrift>0){
                int xa=(int)x/40+1;
                int ya=(int)y/40-1;
                if(xa>=0&&x>0&&ya>=0&&y>0&&xa<xl&&ya<yl){
                    if(backgr[xa][ya]==1){
                        xdrift=-xdrift;
                    }
                }
            }
            if(xdrift<0){
                int xa=(int)x/40-1;
                int ya=(int)y/40-1;
                if(xa>=0&&x>0&&ya>=0&&y>0&&xa<xl&&ya<yl){
                    if(backgr[xa][ya]==1){
                        xdrift=-xdrift;
                    }
                }
            }
            lastdrifty=ydrift;
            ret=running[cur];
            curindex=cur;
            curart=0;
            if(!two){
                cur=(cur+1)%(running.length);
            }
        }
        else{
            if(jumpupb){
                if(!two){
                    lx=lx+xdrift*0.25*(faster+1);
                    ly=ly+ydrift*0.25*(faster+1)+(2.0*(t+0.25)*(t+0.25)-2.0*t*t);
                    t=t+0.25;
                }
                x=(int)lx;
                y=(int)ly;
                if(xdrift>=0){
                    if(curup<jumpup.length){
                        ret=jumpup[curup];
                        curindex=curup;
                        curart=1;
                    }
                    else{
                        ret=jumpup[jumpup.length-1];
                        curindex=jumpup.length-1;
                        curart=1;
                    }
                    if(!two){
                        curup=(curup+1)%jumpup.length;
                    }
                }
                else{
                    if(curdown<jumpdown.length){
                        ret=jumpdown[curdown];
                        curindex=curdown;
                        curart=2;
                    }
                    else{
                        ret=jumpdown[jumpdown.length-1];
                        curindex=jumpdown.length-1;
                        curart=2;
                    }
                    if(!two){
                        curdown=(curdown+1)%jumpdown.length;
                    }
                }
                if(ydrift*0.25*(faster+1)+(2.0*(t+0.25)*(t+0.25)-2.0*t*t)>0){
                    jumpupb=false;
                    jumpdownb=true;
                    curup=0;
                    curdown=0;
                }
            }
            if(jumpdownb){
                if(!two){
                    lx=lx+xdrift*0.25*(faster+1);
                    ly=ly+ydrift*(faster+1)*0.25+(2.0*(t+0.25)*(t+0.25)-2.0*t*t);
                    t=t+0.25;
                }
                x=(int)lx;
                y=(int)ly;
                if(xdrift>=0){
                    if(curdown<jumpdown.length){
                        ret=jumpdown[curdown];
                        curindex=curdown;
                        curart=2;
                    }
                    else{
                        ret=jumpdown[jumpdown.length-1];
                        curindex=jumpdown.length-1;
                        curart=2;
                    }
                    if(!two){
                        curdown=(curdown+1)%jumpdown.length;
                    }
                }
                else{
                    if(curup<jumpup.length){
                        ret=jumpup[curup];
                        curindex=curup;
                        curart=1;
                    }
                    else{
                        ret=jumpup[jumpup.length-1];
                        curindex=jumpup.length-1;
                        curart=1;
                    }
                    if(!two){
                        curup=(curup+1)%jumpup.length;
                    }
                }
            }
        }
        Kugel[]kugel=loa.kugel;
//        for(int i=0;false&&i<200;i++){
//            if(kugel[i]!=null&&!kugel[i].off){
//                if(kugel[i].x>=x&&kugel[i].x>=x+40&&kugel[i].y>=y-40&&kugel[i].y<y){
//                    if(kugel[i].yours==player){
//                        dead=true;
//                        kugel[i].off=true;
//                    }
//                }
//            }
//        }
        if(x==xo&&!jumpb){
            curindex=0;
            curart=0;
            ret=running[0];
        }
        if(two){
            if(oldart==0){
                ret=running[oldindex];
            }
            else if(oldart==1){
                ret=jumpup[oldindex];
            }
            else if(oldart==2){
                ret=jumpdown[oldindex];
            }
        }
        oldindex=curindex;
        oldart=curart;
        return ret;
    }
    public void load(){
        try{
            InputStream fis=AstroJump.getInputStream(source);
            DataInputStream dis=new DataInputStream(fis);
            String s=dis.readLine();
            speed=new Double(dis.readLine()).doubleValue();
            sprung=new Double(dis.readLine()).doubleValue();
            baller=new Double(dis.readLine()).doubleValue();
            Frame f=new Frame();
            int n=new Integer(dis.readLine()).intValue();
            running=new Image[n];
            for(int i=0;i<n;i++){
                running[i]=AstroJump.getImage(dis.readLine());
                AstroJump.app.tracker.addImage(running[i],0);
            }
            n=new Integer(dis.readLine()).intValue();
            jumpup=new Image[n];
            for(int i=0;i<n;i++){
                jumpup[i]=AstroJump.getImage(dis.readLine());
                AstroJump.app.tracker.addImage(jumpup[i],0);
            }
            n=new Integer(dis.readLine()).intValue();
            jumpdown=new Image[n];
            for(int i=0;i<n;i++){
                jumpdown[i]=AstroJump.getImage(dis.readLine());
                AstroJump.app.tracker.addImage(jumpdown[i],0);
            }
            fis.close();
        }
        catch(Exception e){
            System.out.println("figure load error: "+e);
        }
    }
    public FigureObject cloneo(){
        FigureObject ret=new FigureObject();
        ret.speed=speed;
        ret.sprung=sprung;
        ret.baller=baller;
        ret.running=running;
        ret.jumpup=jumpup;
        ret.jumpdown=jumpdown;
        return ret;
    }
}
class StringHolder{
    String[]s=new String[0];
    public boolean contained(String str){
        int n=s.length;
        for(int i=0;i<n;i++){
            if(str.equals(s[i])){
                return true;
            }
        }
        return false;
    }
    public void add(String str){
        if(contained(str)){
        }
        else{
            int n=s.length;
            String[]s2=new String[n+1];
            for(int i=0;i<n;i++){
                s2[i]=s[i];
            }
            s2[n]=str;
            s=s2;
        }
    }
}
class StringPair{
    String[]s=new String[0];
    Object[]o=new Object[0];
    public boolean contained(String str){
        int n=s.length;
        for(int i=0;i<n;i++){
            if(str.equals(s[i])){
                return true;
            }
        }
        return false;
    }
    public void add(String str,Object obj){
        if(contained(str)){
        }
        else{
            int n=s.length;
            String[]s2=new String[n+1];
            Object[]o2=new Object[n+1];
            for(int i=0;i<n;i++){
                s2[i]=s[i];
                o2[i]=o[i];
            }
            s2[n]=str;
            o2[n]=obj;
            s=s2;
            o=o2;
        }
    }
    public Object getObj(String str){
        int n=s.length;
        for(int i=0;i<n;i++){
            if(str.equals(s[i])){
                return o[i];
            }
        }
        return null;
    }
}
class KeyboardMapperApplet extends Panel{
    Label info;
    List l;
    Label aliasl;
    TextField aliastf;
    Label keyl;
    TextField keytf;
    Button add;
    Button remove;
    Button addspecial;
    Button apply;
    Button cancel;
    Button dontapply;
    boolean cancelb=false;
    boolean applyb=false;
    boolean closed=false;
    int kstatus=0;
    int aliasx=0;
    KeyMapperTable kmt;
    String[]alias=new String[0];
    String[]key=new String[0];
    boolean[]special=new boolean[0];
    Applet applet;
    public KeyboardMapperApplet(Applet applet){
        resize(400,400);
        setLayout(null);
        this.applet=applet;
        info=new Label("");
        l=new List();
        aliasl=new Label("alias key: ");
        aliastf=new TextField("");
        keyl=new Label("for key: ");
        keytf=new TextField("");
        add=new Button("add");
        remove=new Button("remove");
        addspecial=new Button("add special key");
        apply=new Button("apply");
        cancel=new Button("cancel");
        dontapply=new Button("don't apply");
        add(info);
        add(l);
        add(aliasl);
        add(aliastf);
        add(keyl);
        add(keytf);
        add(add);
        add(remove);
        add(addspecial);
        add(apply);
        add(cancel);
        add(dontapply);
        info.reshape(10,10,380,27);
        l.reshape(10,40,380,170);
        aliasl.reshape(10,220,80,27);
        aliastf.reshape(110,220,80,27);
        keyl.reshape(210,220,80,27);
        keytf.reshape(310,220,80,27);
        add.reshape(10,250,80,27);
        remove.reshape(110,250,80,27);
        addspecial.reshape(10,280,380,27);
        apply.reshape(10,310,80,27);
        cancel.reshape(210,310,80,27);
        dontapply.reshape(310,310,80,27);
        info.setBackground(Color.white);
        kmt=new KeyMapperTable();
        loadfirst();
        savekmt();
    }
    public InputStream getInputStream(String filename){
        try{
            InputStream is=applet.getClass().getResourceAsStream("/"+filename);
            return is;
        }
        catch(Exception e){
        }
        return null;
    }
    public int getKeyCode(int a){
        byte[]by=new byte[1];
        by[0]=(byte)a;
        String s=new String(by);
        int n=alias.length;
        for(int i=0;i<n;i++){
            if(s.equals(alias[i])){
                String sb=key[i];
                byte[]byb=sb.getBytes();
                return byb[0];
            }
        }
        return a;
    }
    public void savekmt(){
        alias=kmt.alias;
        key=kmt.key;
        special=kmt.special;
    }
    public void restorekmt(){
        kmt.alias=alias;
        kmt.key=key;
        kmt.special=special;
        l.removeAll();
        int n=key.length;
        for(int i=0;i<n;i++){
            if(!special[i]){
                l.addItem(alias[i]+" alias for "+key[i]);
            }
            else{
                byte[]by1=alias[i].getBytes();
                byte[]by2=key[i].getBytes();
                l.addItem("special key "+by1[0]+" alias for "+by2[0]);
            }
        }
    }
    public void loadfirst(){
        try{
            InputStream fis=getInputStream("keymapforus.ini");
            fis.close();
            load("keymapforus.ini");
            info.setText("keymapforus.ini loaded and not applied");
        }
        catch(Exception e){
            info.setText("keymapforus.ini not found");
        }
    }
    public void load(String filename){
        try{
            InputStream fis=getInputStream(filename);
            DataInputStream dis=new DataInputStream(fis);
            String inp=null;
            while((inp=dis.readLine())!=null){
                String inp2=dis.readLine();
                String inp3=dis.readLine();
                if("false".equals(inp3)){
                    kmt.add(inp,inp2);
                }
                else{
                    kmt.addspecial(inp,inp2);
                }
            }
            dis.close();
            fis.close();
            alias=kmt.alias;
            key=kmt.key;
            special=kmt.special;
            l.removeAll();
            int n=alias.length;
            for(int i=0;i<n;i++){
                if(!special[i]){
                    l.addItem(alias[i]+" alias for "+key[i]);
                }
                else{
                    byte[]by1=alias[i].getBytes();
                    byte[]by2=key[i].getBytes();
                    l.addItem("special key "+by1[0]+" alias for "+by2[0]);
                }
            }
        }
        catch(Exception e){
            info.setText("File not found: "+filename);
        }
    }
    public boolean handleEvent(Event evt){
        if(evt.id==Event.KEY_ACTION||evt.id==Event.KEY_PRESS){
            if(kstatus==1){
                aliasx=evt.key;
                kstatus=2;
                info.setText("type key");
            }
            else if(kstatus==2){
                int keyx=evt.key;
                kstatus=0;
                info.setText("special key added");
                info.setBackground(Color.white);
                byte[]by1=new byte[1];
                by1[0]=(byte)aliasx;
                String s1=new String(by1);
                byte[]by2=new byte[1];
                by2[0]=(byte)keyx;
                String s2=new String(by2);
                kmt.addspecial(s1,s2);
                l.addItem("special key "+((byte)aliasx)+" alias for "+((byte)keyx));
            }
        }
        if(evt.id==Event.ACTION_EVENT){
            if(evt.target==add){
                String a=aliastf.getText();
                String b=keytf.getText();
                if((a.length()!=1)||(b.length()!=1)){
                    info.setText("Error: alias and key must have length 1");
                    return false;
                }
                kmt.add(a,b);
                l.addItem(a+" alias for "+b);
                aliastf.setText("");
                keytf.setText("");
            }
            if(evt.target==remove){
                int ind=l.getSelectedIndex();
                if(ind!=-1){
                    l.remove(ind);
                    kmt.remove(ind);
                }
            }
            if(evt.target==addspecial){
                info.setText("type alias");
                info.setBackground(Color.yellow);
                kstatus=1;
            }
            if(evt.target==apply){
                alias=kmt.alias;
                key=kmt.key;
                special=kmt.special;
                applyb=true;
                closed=true;
                hide();
            }
            if(evt.target==cancel){
                restorekmt();
                cancelb=true;
                closed=true;
                hide();
            }
            if(evt.target==dontapply){
                applyb=false;
                info.setText("KeyboardMapper isn't applied");
            }
        }
        return false;
    }
}
class KeyMapperTable{
    String[]alias=new String[0];
    String[]key=new String[0];
    boolean[]special=new boolean[0];
    public KeyMapperTable(){
    }
    public void reset(){
        alias=new String[0];
        key=new String[0];
        special=new boolean[0];
    }
    public void add(String a,String b){
        int n=alias.length;
        String[]aliasb=new String[n+1];
        String[]keyb=new String[n+1];
        boolean[]specialb=new boolean[n+1];
        for(int i=0;i<n;i++){
            aliasb[i]=alias[i];
            keyb[i]=key[i];
            specialb[i]=special[i];
        }
        aliasb[n]=a;
        keyb[n]=b;
        specialb[n]=false;
        alias=aliasb;
        key=keyb;
        special=specialb;
    }
    public void addspecial(String a,String b){
        int n=alias.length;
        String[]aliasb=new String[n+1];
        String[]keyb=new String[n+1];
        boolean[]specialb=new boolean[n+1];
        for(int i=0;i<n;i++){
            aliasb[i]=alias[i];
            keyb[i]=key[i];
            specialb[i]=special[i];
        }
        aliasb[n]=a;
        keyb[n]=b;
        specialb[n]=true;
        alias=aliasb;
        key=keyb;
        special=specialb;
    }
    public void remove(int ind){
        int n=alias.length;
        if(n>0){
            String[]aliasb=new String[n-1];
            String[]keyb=new String[n-1];
            boolean[]specialb=new boolean[n-1];
            int ib=0;
            for(int i=0;i<n;i++){
                if(i==ind){
                }
                else{
                    aliasb[ib]=alias[i];
                    keyb[ib]=key[i];
                    specialb[ib]=special[i];
                    ib=ib+1;
                }
            }
            alias=aliasb;
            key=keyb;
            special=specialb;
        }
    }
}
